% Disclaimer:  IMPORTANT:  This software was developed at the National Institute of Standards and Technology by employees of the Federal Government in the course of their official duties. Pursuant to title 17 Section 105 of the United States Code this software is not subject to copyright protection and is in the public domain. This is an experimental system. NIST assumes no responsibility whatsoever for its use by other parties, and makes no guarantees, expressed or implied, about its quality, reliability, or any other characteristic. We would appreciate acknowledgment if the software is used. This software can be redistributed and/or modified freely provided that any derivative works bear some notice that they are derived from it, and any modified versions bear some notice that they have been modified.




% Celltracker variables
% raw_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data_full';
% segmented_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data_full\segmented_images';
% tracked_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data_full\tracked_images';
% raw_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data';
% segmented_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data\segmented_images';
% tracked_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data\tracked_images';

raw_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data';
segmented_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data\segmented_images';
tracked_images_path = 'C:\majurski\BitBucket\Cell_Tracker_GUI\test_data\tracked_images';
raw_images_common_name = 'phase_image_';
segmented_images_common_name = 'segmented_image_';
tracked_images_common_name = 'tracked_image_';

cell_size_threshold = 200;
max_centroids_distance = 150;
weight_overlap = 100;
weight_centroids = 50;
weight_size = 20;
division_overlap_threshold = 20;
fusion_overlap_threshold = 20;
cell_life_threshold = 32;
circularity_threshold = 30;
daughter_size_similarity = 50;
daughter_aspect_ratio_similarity = 70;
enable_fusion_flag = 1;
frames_to_track = '';
cell_density = 0;
distance_to_border = 0;
disable_cell_mitosis_flag = 0;
number_of_frames = 0;

% "Raw Images Path"                         <String>
% "Segmented Images Path"                   <String> 
% "Tracked Images Path"                     <String> 
% "Segmented Images Common Name"            <String>
% "Raw Images Common Name"                  <String>
% "Tracked Images Common Name"              <String>
% "Weight Overlap"                          <numeric>
% "Weight Centroids"                        <numeric>
% "Weight Size"                             <numeric>
% "Max Centroids Distance"                  <numeric>
% "Frames To Track"                         <String>
% "Min Mitotic Overlap"                     <numeric>
% "Daughter Size Similarity"                <numeric>
% "Daughter Aspect Ratio Similarity"        <numeric>
% "Circularity Index"                       <numeric>
% "Number Frames to Check Circularity"      <numeric>
% "Enable Cell Mitosis"                     <boolean>
% "Min Cell Life CI Threshold"              <numeric>
% "Cell Death Delta Centroid Threshold"     <numeric>
% "Cell Density Affects CI"                 <boolean>
% "Border Cell Affects CI"                  <boolean>
% "Cell Fusion Min Area"                    <numeric>
% "Min Cell Fusion Overlap"                 <numeric>
% "Enable Cell Fusion"                      <boolean>

% batchmode_inputs = {{'Default', 'none', ''},...
%     {'Raw Images Path', 'char', 'raw_images_path'},...
%     {'Segmented Images Path', 'char', 'segmented_images_path'},...
%     {'Tracked Images Path', 'char', 'tracked_images_path'},...
%     {'Segmented Images Common Name', 'char', 'segmented_images_common_name'},...
%     {'Raw Images Common Name', 'char', 'raw_images_common_name'},...
%     {'Tracked Images Common Name', 'char', 'tracked_images_common_name'},...
%     {'Weight Overlap', 'numeric', 'weight_overlap'},...
%     {'Weight Centroids', 'numeric', 'weight_centroids'},...
%     {'Weight Size', 'numeric', 'weight_size'},...
%     {'Max Centroids Distance', 'numeric', 'max_centroids_distance'},...
%     {'Frames To Track', 'char', 'frames_to_track'},...
%     {'Min Mitotic Overlap', 'numeric', 'division_overlap_threshold'},...
%     {'Daughter Size Similarity', 'numeric', 'daughter_size_similarity'},...
%     {'Daughter Aspect Ratio Similarity', 'numeric', 'daughter_aspect_ratio_similarity'},...
%     {'Circularity Index', 'numeric', 'circularity_threshold'},...
%     {'Number Frames to Check Circularity', 'numeric', 'number_of_frames_check_circularity'},...
%     {'Enable Cell Mitosis', 'logical', 'enable_cell_mitosis_flag'},...
%     {'Min Cell Life CI Threshold', 'numeric', 'cell_life_threshold'},...
%     {'Cell Death Delta Centroid Threshold', 'numeric', 'cell_apoptosis_delta_centroid_thres'},...
%     {'Cell Density Affects CI', 'logical', 'cell_density_ci_flag'},...
%     {'Border Cell Affects CI', 'logical', 'border_cell_ci_flag'},...
%     {'Cell Fusion Min Area', 'numeric', 'cell_size_threshold'},...
%     {'Min Cell Fusion Overlap', 'numeric', 'fusion_overlap_threshold'},...
%     {'Enable Cell Fusion', 'logical', 'enable_cell_fusion_flag'} };

% Cell_tracker_GUI_v4('Default', 'SegmentedImagesPath',segmented_images_path);

Cell_tracker_GUI_v4('RawImagesPath', raw_images_path,  ...
	'SegmentedImagesPath',  segmented_images_path,  ...
	'TrackedImagesPath',  tracked_images_path,  ...
	'RawImagesCommonName',  raw_images_common_name,  ...
	'SegmentedImagesCommonName', segmented_images_common_name, ...
	'TrackedImagesCommonName', tracked_images_common_name, ...
	'CellFusionMinArea', cell_size_threshold, ...
	'CircularityIndex', circularity_threshold, ...
	'MaxCentroidsDistance', max_centroids_distance, ...
	'WeightOverlap', weight_overlap, ...
	'WeightCentroids', weight_centroids, ...
	'WeightSize', weight_size, ...
	'MinMitoticOverlap', division_overlap_threshold, ...
	'MinCellFusionOverlap', fusion_overlap_threshold, ...
	'MinCellLifeCIThreshold', cell_life_threshold, ...
	'CircularityIndex', circularity_threshold, ...
	'DaughterSizeSimilarity', daughter_size_similarity, ...
	'DaughterAspectRatioSimilarity', daughter_aspect_ratio_similarity, ...
	'EnableCellFusion', enable_fusion_flag, ...
	'FramestoTrack', frames_to_track, ...
	'CellDensityAffectsCI', cell_density, ...
	'BorderCellAffectsCI', distance_to_border, ...
	'EnableCellMitosis', 1, ...
	'NumberFramestoCheckCircularity', number_of_frames);


