function [ im1_regions, im2_regions ] = find_bipartite_pairs( img1, img2 )
%given a pair of labeled images, this function finds objects in each pair
%of images that have no neighbors and overlap with only one object in the
%other image, and returns the labels of those images 
%
% there's probably some graph-ical term for that but it current escapes me
% something like bipartite pairs or something.
%
% gj@cs.cmu.edu

%remove any regions that have touching neighbors
img1(img1<=0) = 0;
img2(img2<=0) = 0;


img1(has_neighbors(img1, 2) ~= 0) = 0;
img2(has_neighbors(img1, 2) ~= 0) = 0;

%return the interaction graph for overlappping neighbors
[overlap_graph, im1_regions, im2_regions] = has_overlap(img1, img2);

%return the list of overlapping region-pairs that only overlap with a
%single region

overlap_graph = full(overlap_graph);

%sum the graph in the x and y dimensions, 
num_neighbors = repmat(sum(overlap_graph,1), [size(overlap_graph,1), 1]);
num_neighbors = num_neighbors + repmat(sum(overlap_graph,2), [1, size(overlap_graph,2)]);

overlap_graph = num_neighbors.*overlap_graph;

inds = find(overlap_graph == 2);

[im1_region_inds, im2_region_inds] = ind2sub(size(overlap_graph), inds);

im1_regions = im1_regions(ismember(im1_regions, im1_region_inds));
im2_regions = im2_regions(ismember(im2_regions, im2_region_inds));

end

