function img_info = get_image_info(imgdir, resultsdir)

if ~exist('imgdir', 'var')
    script_add_to_path
end

[collectiondirs, collectiondirnames] = getSubDirs(imgdir, 'Alon*');

segdirname = 'seg';
seg_save_parent = [resultsdir filesep segdirname];
if ~exist(seg_save_parent, 'dir')
    mkdir(seg_save_parent)
end

savefile = [resultsdir filesep 'img_info.mat'];

c = 1;

if ~exist(savefile, 'file')
    disp([savefile ' does not exist. Making new image paths file']);
    %for any Alon... dir
    for i = 1:length(collectiondirs)
        [moviedirs, moviedirnames] = getSubDirs(collectiondirs{i});


        %for every movie dir
        for j = 1:length(moviedirs)

            [replicate_dir, replicatedirnames] = getSubDirs([moviedirs{j} filesep 'Fluor2'], 'P*');

            %there should only be one dir here


            %make sure there's a frame dir 
            for q = 1:length(replicate_dir);
                frames = dir([replicate_dir{q} filesep '*.TIF']);
                frames = sort_nat({frames(:).name});

                %for every frame
                for k = 1:length(frames)

                    collection{c} = collectiondirnames{i};
                    movie{c} = moviedirnames{j};
                    replicate{c} = replicatedirnames{q};
                    frame{c} = frames{k};

                    collection_num(c) = i;
                    movie_num(c) = j;


                    frame_num(c) = k;
                    replicate_num(c) = q;

                    img_root = [filesep collectiondirnames{i} filesep moviedirnames{j} '_' replicatedirnames{q} filesep];

                    seg_name_root{c} = img_root;
                    
                    seg_dna_name{c} = [img_root 'seg_' num2str(k) '_dna.tif'];
                    seg_cell_name{c} = [img_root 'seg_' num2str(k) '_cell.tif'];

                    img_path{c} = [collectiondirnames{i} filesep moviedirnames{j} filesep 'Fluor2' filesep replicatedirnames{q} filesep frames{k}];
                    img_exists(c) = exist([imgdir filesep img_path{c}], 'file');
    %                 
                    
                    c = c+1;
                    
    %                 [can_start, final_name, final_exists, temp_name] = chunk_start([imgsaveparent filesep num2str(i) '_' num2str(j) '_' num2str(k)]);
    %                 
    %                 if can_start && ~exist(seg_cell_file, 'file')
    %                     disp(['C:' num2str(i) filesep num2str(length(collectiondirs)), '   M:' num2str(j) filesep num2str(length(moviedirs)), '   F:' num2str(k) filesep num2str(length(frames))])
    %     
    %                     img = ml_readimage([framedir{q} filesep frames{k}]);
    %                     [seg_dna, seg_cell] = segCells_alon(img);
    % 
    %                     imwrite(seg_dna, seg_dna_file, 'tif');
    %                     imwrite(seg_cell, seg_cell_file, 'tif');
    %                     
    %                 end
                end
            end
        end
    end

    save(savefile, 'collection', 'movie', 'frame', 'replicate', 'collection_num', 'movie_num', 'frame_num', 'replicate_num', 'seg_dna_name', 'seg_cell_name', 'img_path', 'img_exists', 'seg_name_root', 'c')
else
    disp([savefile ' exists. Loading...']);
    load(savefile)
end

img_info.collection = collection;
img_info.movie = movie;
img_info.frame = frame;
img_info.replicate = replicate;

img_info.collection_num = collection_num;
img_info.movie_num = movie_num;
img_info.frame_num = frame_num;
img_info.replicate_num = replicate_num;

img_info.img_path = cellfun(@(x) [imgdir filesep x], img_path, 'UniformOutput', false);
img_info.img_exists = img_exists;

img_info.seg_dna_name = cellfun(@(x) [seg_save_parent filesep x], seg_dna_name, 'UniformOutput', false); 
img_info.seg_cell_name = cellfun(@(x) [seg_save_parent filesep x], seg_cell_name, 'UniformOutput', false); 
img_info.seg_root = seg_name_root;
img_info.seg_save_parent = seg_save_parent;

img_info.img_dir = imgdir;
end
