function [ neighbor_img ] = has_neighbors( img, dist, conn )
%takes a binary valued image, and returns a binary image
%and lables regions iwth a 1 if it has a neighbor at a distance n

if ~exist('dist', 'var')
    dist = 2; 
end

if ~exist('conn', 'var')
    if size(img,3) == 1
        conn = 4;
    else
        conn = 26;
    end
end

img = double(img);
neighbor_img = zeros(size(img));

img_labeled = bwlabeln(img);

region_nums = unique(img_labeled(:));

region_nums(region_nums == 0) = [];

%I could probably use a stack or something here
while ~isempty(region_nums)
    
    region_dists = bwdist(img_labeled == region_nums(1));
    region_dists(img_labeled == 0) = inf;
    region_dists(img_labeled == region_nums(1)) = inf;
    
    img_neighbors = (region_dists <= dist).*img_labeled;
    img_neighbors = unique(img_neighbors);
    img_neighbors(img_neighbors == 0) = [];
    
    if ~isempty(img_neighbors(:))
        neighbor_img(ismember(img_labeled, [region_nums(1); img_neighbors])) = 1;
        region_nums(ismember(region_nums, img_neighbors)) = [];
    end
    
    region_nums(1) = [];
end
    
end

