function [ overlap, im1_regions, im2_regions] = has_overlap( im1, im2 )
%%returns a sparse matrix indicating the overlapping regions in im1 and im2
%with im1_regions and im2_regions indexing into the sparse matrix

%use bwlabeln on the images before hand if using a binary image

im1_regions = unique(im1(im1 ~= 0));
im2_regions = unique(im2(im2 ~= 0));

overlap = sparse(length(im1_regions), length(im2_regions));

for i = 1:length(im1_regions)
    overlap_regions = double(im1 == im1_regions(i)).*double(im2);
    overlap_regions = unique(overlap_regions(overlap_regions ~= 0));
    
    overlap(im1_regions(i), overlap_regions) = 1;
end


end

