function img2slml_alon_nuc_v3(projectdir, build )
% Generates the H1299 nuclear shape model
% from G. R. Johnson, T. E. Buck,D. P. Sullivan, G. K. Rohde, and 
% R. F. Murphy (2015) Joint modeling of cell and nuclear shape variation. 
% Molecular Biology of the Cell,
% http://murphylab.web.cmu.edu/software/2015_MBoC_Cell_And_Nuclear_Shape/index.html
%
% Author: Gregory R. Johnson (gj@cs.cmu.edu)
% Created: May 21, 2015
% Nov 2, 2015 - added header block - gj@cs.cmu.edu

if ~exist('projectdir', 'var')
    projectdir = [];
end

if ~exist('build', 'var')
    build = false;
end

script_alon_setup_v3


param.model.diffeomorphic.useCurrentResults = false;

param.model.diffeomorphic.shape_to_model = 'nuc';
param.tempparent = 'temp_nuc';
param.model.filename = 'cellModel_nuc.mat';

param.model.diffeomorphic.com_align = 'body';

if build
    param.model.diffeomorphic.useCurrentResults = true;

    param.model.diffeomorphic.embedding.method = 'regress landmark';
    param.model.diffeomorphic.embedding.weighted = false;
end


rng()
model = img2slml(dimensionality, im_dna, im_cell, [], param);

system(['chmod ugo+rx ' expdir])




end

