function [ kde, p_x ] = kde_learn( pos, kernelrange, cv )
%LEARN_GAUSSIAN_KERNEL Summary of this function goes here
%   Detailed explanation goes here

dmat = squareform(pdist(pos));

%do a grid search over the kernel range
pred_err = zeros(size(kernelrange));
for i = 1:length(kernelrange)
    [~, pred_pos] = opt_func(pos, dmat, kernelrange(i), true);
    pred_err(i) = sum(sum((pos - pred_pos).^2,2),1);
end

%then do a more local search using matlabs built in function (this could be
%upgraded to a binary search or some other search method)
[~, min_ind] = min(pred_err);
[kde, ~, exitflag] = fminsearch(@(x) opt_func(pos, dmat, x, true), kernelrange(min_ind), optimset('Display','iter', 'MaxIter', 2000));

p_x = zeros(size(pos,1),1);
%compute the kde for each element
for i = 1:size(pos,1)
    w = mvnpdf(dmat(i,:)', 0, kde);
    p_x(i) = sum(w);
end

end


function [diff, pred_pos] = opt_func(pos,dmat,h, cv)
    %learn a kernel for KDE

    if ~exist('dmat', 'var') | isempty(dmat)
        dmat = squareform(pdist(pos0));
    end

    if ~exist('cv', 'var') | isempty(cv)
        cv = true;
    end


    %if not positive definite, the kernel is no good
    if h <= 0
        diff = inf;
        pred_pos = inf;
        return
    end

    pred_pos = inf(size(pos));

    for i = 1:size(pos,1)


    %     t_dist(t_dist > 0.5) = t_dist(t_dist > 0.5)-1;
    %     t_dist(t_dist < -0.5) = t_dist(t_dist < -0.5)+1;
    %     
        ddist = dmat(i,:)';

        w = mvnpdf(ddist, 0, h);

        if isnumeric(cv)
            w(cv == cv(i)) = 0;
        elseif cv
            w(i) = 0;
        end

        if all(w == 0)
            w(:) = 1;
        end

        w = w./sum(w(:));

        pred_pos(i,:) = pos'*w;

    end

    diff = sum(sum((pos-pred_pos).^2,2),1);

end

