% script_alon_setup
% 
% load('cellModel.mat')

saveparentdir = [figuredir filesep mfilename];
if ~exist(saveparentdir, 'dir')
    mkdir(saveparentdir)
end

uconditions = unique(object_info.obj_condition);

for i = 1:length(uconditions)
    saveconddir = [saveparentdir filesep 'cond' num2str(i)];
    if ~exist(saveconddir, 'dir')
        mkdir(saveconddir)
    end
    
    condition_inds = object_info.obj_condition == uconditions(i);
    
    umovieids = unique(object_info.obj_umovieid(condition_inds));
    
	for j = 1:length(umovieids)
        savemoviedir = [saveconddir filesep 'movie' num2str(j)];
        if ~exist(savemoviedir, 'dir')
            mkdir(savemoviedir)
        end
        
        
        obj_inds = condition_inds & (object_info.obj_umovieid == umovieids(j));
        
        trans_inds = find(ismember(object_info.transition_obj_inds(:,1), find(obj_inds)));
        
        for k = 1:length(trans_inds)
            disp([num2str(i) filesep num2str(j) filesep num2str(k)])
            
            savefile = [savemoviedir filesep 'trans' num2str(k) '.tif'];
            if ~exist(savefile, 'file')
                trans_pair = object_info.transition_obj_inds(trans_inds(k),:);
                
                img_pair = [model.cellShapeModel.imfunc(trans_pair(1)), model.cellShapeModel.imfunc(trans_pair(2))]/2;
                
                imwrite(img_pair, savefile, 'tif')
                
            end
            
        
        end
        
    end
end
