script_add_to_path

disp(mfilename)

collectionnum = 3;
nframes = 65;
ntransitions = 125;

img_params.collectionnum = 3;
img_params.nframes = 65;
img_params.ntransitions = 125;


rng(0);

savedir = [resultsdir filesep 'model_v2'];
if ~exist(savedir, 'dir')
    mkdir(savedir)
end

cd(savedir)

settingsfile = [savedir filesep 'modelSettings.mat'];

img_info = get_image_info_v2(imgdir, resultsdir);

disp_info = find_pairs_and_displacements_v2(img_info, resultsdir);

rng(0);
object_info = get_objects_v2(img_info, disp_info, resultsdir, img_params);



dimensionality = '3D';
param.model.name = 'example1';
param.model.id = 'num2str(now)';
param.model.downsampling = [1,1,1];
param.model.resolution = [0.34, 0.34, 0.34];
param.model.filename = 'cellModel.mat';
param.train.flag = 'framework';
param.nucleus.type = 'diffeomorphic';
param.cell.type = 'diffeomorphic';
param.protein.type = 'vesicle';
param.verbose = true;
param.debug = true;
param.downsample = [1, 1, 1];

param.skip_ls = true;

param.model.diffeomorphic.com_align = false;


im_cell = object_info.img_cell_file;
im_dna = object_info.img_dna_file;
  

% param.preprocess = false;
param.saveIntermediateResults = false;
% param.model.diffeomorphic.useCurrentResults = true;


param.model.diffeomorphic.embedding.method = 'regress landmark';
param.model.diffeomorphic.embedding.maximum_shape_space_dimension = 7;

param.model.diffeomorphic.number_windows = 1;

param.model.diffeomorphic.distances_computed_before_saving = 20;