script_alon_setup_v3

modelname = 'cellModel_nuc_align.mat';

load([savedir filesep modelname])

pos = model.cellShapeModel.positions;
uconditions = unique(object_info.obj_condition);

load([figuredir filesep 'script_kde_trans_model_alon_cellModel_nuc_align/densities.mat']);

%for each condition, find objects with low probability and objects with high
%probability.
uconditions = unique(object_info.obj_condition);
for condition_ind = 1:length(uconditions)
    ucondinds = find(object_info.obj_condition == uconditions(condition_ind)) ;
    cond_dens = densities(ucondinds);
    
    prct_10 = prctile(cond_dens, 10);
    prct_90 = prctile(cond_dens, 90);
    
    low_dens = cond_dens <= prct_10;
    high_dens = cond_dens > prct_90;
    
    low_dens_inds{condition_ind} = ucondinds(low_dens);
    high_dens_inds{condition_ind} = ucondinds(high_dens); 
end

%retreive movie name, and frame number, and segmented image for each object
for i = 1:length(low_dens_inds)
    disp(num2str(i))
    
    for j = 1:length(high_dens_inds{i})
        disp(num2str(j))
        
        img_ind = high_dens_inds{i}(j);
        
        objid = object_info.uobjids(img_ind);
        
        collection = object_info.collectionnums(objid);
        replicate = object_info.replicatenums(objid);
        movieid = object_info.movieid(objid);
        framenum = object_info.framenums(objid);
        imgnum = object_info.imgnums(objid);
        
        objnum = object_info.obj1_nums(objid);
        
        img_path = img_info.img_path{imgnum};
        seg_img_file = img_info.seg_cell_name{imgnum};
        
        disp(img_path);
        load(seg_img_file)
        imshow(seg_cell == objnum)
        
    end
end
    