

script_alon_setup_v2

 modelfiles = {'cellModel_nuc_align.mat', 'cellModel_cell.mat', 'cellModel_nuc.mat'};
 modelfiles{1} = 'cellModel_nuc_align.mat';
 
% load([savedir filesep 'temp_nuc_align/diffeomorphic/distances_sparse.mat']);
% dists_incomplete{1} = full(distances_incomplete)+full(distances_incomplete)';
% 

savedir = [resultsdir filesep 'embed_best'];
if ~exist(savedir, 'dir')
    mkdir(savedir)
end


dists_incomplete_all = cell(1, length(modelfiles));

disp('Preparing distance files')

for i = 1:length(modelfiles)
    dists_incomplete_file = [savedir filesep 'distances_incomplete_' modelfiles{i}];

    if ~exist(dists_incomplete_file, 'file')
        load(modelfiles{i});
        dists_incomplete = model.cellShapeModel.distances_incomplete;
        save(dists_incomplete_file, 'dists_incomplete', 'modelfiles')
    else
        load(dists_incomplete_file)
    end
    dists_incomplete_all{i} = dists_incomplete;
end

dists_incomplete = dists_incomplete_all;


for i = 1:length(modelfiles) 
    disp(['Finding best embedding for ' modelfiles{i}]);
    param = [];
    param.calceuc = false;
    param.paralleldir  = [savedir filesep 'embed_temp_' modelfiles{i}(1:end-4)];
    
    embedding_best_file{i} = [savedir filesep 'embed_best_pos_' modelfiles{i}];
    if ~exist(embedding_best_file{i}, 'file')
        
        [struct_euc, struct_orig, param] = compute_embedding_dimensionality( dists_incomplete{i}, param );
        if ~isempty(struct_orig)
            save(embedding_best_file{i}, 'struct_orig', 'param')
        end
    end
end



param = [];
for i = 1:length(modelfiles)
    disp(['Computing triangulation and saving best embedding for ' modelfiles{i}]);
    model_best_files{i} = [savedir filesep modelfiles{i}];
    if ~exist(model_best_files{i}, 'file') && exist(embedding_best_file{i}, 'file')
        load(modelfiles{i})
        load(embedding_best_file{i});
        param.positions = struct_orig.pos;
        [ embedding_model ] = embed_distance_matrix( model.cellShapeModel.distances_incomplete, param);
        
        model.cellShapeModel = ml_initparam(embedding_model, model.cellShapeModel);
        save(model_best_files{i}, 'model', '-v7.3')
    end
end