script_alon_setup

saveparent = [resultsdir filesep mfilename];
% saveparent = ['/home/gj/projects/shapeSpace/' mfilename];


if ~exist(saveparent, 'dir')
    mkdir(saveparent)
end



% positions_cell_file = [saveparent filesep 'positions_cell.mat'];
% positions_nuc_file = [saveparent filesep 'positions_nuc.mat'];
% 
% 
% if ~exist(positions_cell_file, 'file')
%     load([resultsdir filesep 'embed_best' filesep 'cellModel_cell.mat'])
%     p_cell_all = model.cellShapeModel.positions;
%     clear model
%     
%     save(positions_cell_file, 'p_cell_all')
% else
%     load(positions_cell_file)
% end
% 
% if ~exist(positions_nuc_file, 'file')
% 
%     load([resultsdir filesep 'embed_best' filesep 'cellModel_nuc.mat'])
%     p_nuc_all = model.cellShapeModel.positions;
%     clear model
%     
%     save(positions_nuc_file, 'p_nuc_all')
% else
%     load(positions_nuc_file)
% end

positions_cell_file = [saveparent filesep 'positions_cell.mat'];
positions_nuc_file = [saveparent filesep 'positions_nuc.mat'];


if ~exist(positions_cell_file, 'file')
    load([resultsdir filesep 'embed_best' filesep 'embed_temp2' filesep 'embed_7.mat'])
    p_cell_all = pos_temp;
    
    save(positions_cell_file, 'p_cell_all')
else
    load(positions_cell_file)
end

if ~exist(positions_nuc_file, 'file')
    load([resultsdir filesep 'embed_best' filesep 'embed_temp3' filesep 'embed_7.mat'])
    p_nuc_all = pos_temp;
    clear model
    
    save(positions_nuc_file, 'p_nuc_all')
else
    load(positions_nuc_file)
end


ucond = unique(object_info.obj_condition);

% rng('shuffle')
% perm_inds = randperm(length(ucond));
% ucond = ucond(perm_inds);

niter = 250;

alldatfile = [saveparent filesep 'alldat.mat'];
if ~exist(alldatfile, 'file')
    for i = 1:length(ucond)
        disp(['ucond ' num2str(ucond(i))])
        savedir = [saveparent filesep 'c' num2str(ucond(i))];

        inds = object_info.obj_condition == ucond(i);
        cvinds = object_info.obj_umovieid(inds);

        p_cell = p_cell_all(inds,:);
        p_nuc = p_nuc_all(inds,:);
        
         [pval_nuc{i}, pval_nuc_all(i), pval_cell{i}, pval_cell_all(i)] = test_cell_nuc_pred_linreg(p_cell, p_nuc, cvinds, niter, savedir);

%         [pval_nuc{i}, pval_nuc_all(i), pval_cell{i}, pval_cell_all(i)] = test_cell_nuc_pred_linreg(p_cell, p_nuc, cvinds, niter, savedir);
    end

%       save(alldatfile, 'pval_nuc', 'pval_nuc_all', 'pval_cell', 'pval_cell_all')

else
    load(alldatfile)
end

ucond = sort(ucond);

for i = 1:length(ucond)
    mse_nuc(i) = mean(pred_err_nuc{i});
    mse_cell(i) = mean(pred_err_cell{i});

    p_nuc_err{i} = mean(repmat(pred_err_nuc{i}, 1, niter) >= [pred_err_nuc_perm{i}{:}],2);
    p_nuc_mse(i) = mean(repmat(mse_nuc(i), 1, niter) >= mean([pred_err_nuc_perm{i}{:}],1),2);
    p_cell_err{i} = mean(repmat(pred_err_cell{i}, 1, niter) >= [pred_err_cell_perm{i}{:}],2);
    p_cell_mse(i) = mean(repmat(mse_cell(i), 1, niter) >= mean([pred_err_cell_perm{i}{:}],1),2);
end

t = table(object_info.condition_names', mse_nuc', p_nuc_mse', mse_cell', p_cell_mse');
t.Properties.VariableNames = {'Condition', 'NuclerShapeMSE', 'NuclerShapeMSEp', 'CellShapeMSE', 'CellShapeMSEp'};

writetable(t, [saveparent filesep 'table.csv'])

[mse_nuc, mse_cell]

figure('color', 'w'), 
subplot(1,2, 1)
bar(mse_nuc')
xlabel('condition')
ylabel('mean squared prediction error')

subplot(1,2, 2), bar(mse_cell')
xlabel('condition')


param.subsize = 6000;
param.synthorder = randperm(size(p_nuc_all,1));

cell_shape_figure = [saveparent filesep 'shapeSpace_cell.tif'];
if ~exist(cell_shape_figure, 'file')
    load('cellModel_cell.mat')
    figure, 
    showShapeSpaceFigure(model, object_info.obj_condition, param);
    saveas(gcf, cell_shape_figure, 'tif')
end
    
param.subsize = 1000;
nuc_shape_figure = [saveparent filesep 'shapeSpace_nuc.tif'];
if ~exist(nuc_shape_figure, 'file')
    load('cellModel_nuc.mat')
    figure, 
    showShapeSpaceFigure(model, object_info.obj_condition, param);
    saveas(gcf, nuc_shape_figure, 'tif')
end

