
if ~exist('shapespacedir', 'var')

    %list of possible project dirs
    shapespacedirs = {'/projects/cellorganizer/gj/shapeSpace/', ...
                 '/Volumes/Data/Documents/Murphylab/projects/shapeSpace/', ...
                 '/Users/Greg/Documents/murphylab/projects/shapeSpace'};

    for i = 1:length(shapespacedirs)
        if exist(shapespacedirs{i}, 'dir')
            shapespacedir = shapespacedirs{i};
        end
    end

end

addpath(genpath([shapespacedir filesep 'code']));

parentdir = [shapespacedir filesep 'BBBC021' filesep];

cd(parentdir)

addpath(genpath([parentdir filesep 'code']));

resultsdir = [parentdir filesep 'results'];
if ~exist(resultsdir, 'dir')
    mkdir(resultsdir)
end

script_getBBBCdata

% parentdir = '/projects/cellorganizer/gj/bbbc021/';
% if ~exist(parentdir, 'dir')
%     parentdir = '/Volumes/Data/Documents/Murphylab/projects/cellOrganizer/BBBC021/';
% end

script_segImgs

model_settings_path = [parentdir filesep 'model_settings_sub.mat'];

im_dna = {};
im_cell = {};
imnum = [];

if ~exist(model_settings_path, 'file')

    maxcells = 50;
    c = 1;
    for i = 1:length(segfile)
        load(segfile{i});

        cellmask = bwlabel(cellmask >= 2);

        mask_ids = unique(cellmask(:));

        %remove the ID that corresponds to background
        mask_ids(mask_ids == 0) = []; 

        mask_ids = mask_ids(randperm(length(mask_ids)));

        disp([num2str(i) ': ' num2str(length(mask_ids))]);

        numinds = min([maxcells, length(mask_ids)]);
        for j = 1:numinds

            mask_region = cellmask == mask_ids(j);

            [cell_region, crop_bounds] = pc12_cropImg(mask_region);

            dna_region = dnamask.*(cellmask == mask_ids(j));
            dna_region = dna_region(crop_bounds(1):crop_bounds(2), crop_bounds(3):crop_bounds(4));


            %'legal' dna are labeled as 2s, illegal dna (too small or too big)
            %are 1s
            if all(ismember(dna_region(:), [0,2]))
                cell_region = imresize(cell_region, 0.5, 'nearest');
                dna_region = imresize(dna_region, 0.5, 'nearest');
                im_cell{c} = @() cell_region;
                im_dna{c} = @() dna_region;

                imnum(c) = i;
                cellnum(c) = mask_ids(j);
                c = c+1;
            end
        end
    end
    save(model_settings_path, 'im_dna', 'im_cell', 'imnum', 'cellnum');
end

load(model_settings_path)

condition = imgs_compound(imnum);

dimensionality = '3D';
param.model.name = '';
param.model.id = 'num2str(now)';
param.model.resolution = [1, 1, 1];
param.model.filename = 'cellModel.mat';
param.nucleus.type = 'diffeomorphic';
param.cell.type = 'diffeomorphic';
param.train.flag = 'framework';
param.verbose = true;
param.debug = true;
param.model.downsampling = [1,1,1];
param.preprocess = true;

param.skip_ls = true;

param.model.diffeomorphic.com_align = false;


% param.preprocess = false;
param.saveIntermediateResults = false;
% param.model.diffeomorphic.useCurrentResults = true;


param.model.diffeomorphic.embedding.method = 'regress landmark';
param.model.diffeomorphic.embedding.maximum_shape_space_dimension = 7;

param.model.diffeomorphic.number_windows = 1;

param.model.diffeomorphic.distances_computed_before_saving = 20;
