function [ confmat ] = crossVal( features, labels, crossvalind, classifier )
%CROSSVALRF Summary of this function goes here
%   Detailed explanation goes here

ucv = unique(crossvalind);
[ulabels, ~, labels] = unique(labels);


confmat = zeros(length(ulabels), length(ulabels), length(ucv));

for i = 1:length(ucv)
    
    disp(['Training CV ' num2str(i) filesep num2str(length(ucv))])
    testinds = crossvalind == ucv(i);
    traininds = ~testinds;

    testfeats = features(testinds,:);
    testlabels = labels(testinds);

    trainfeats = features(traininds,:);
    trainlabels = labels(traininds);

    %Zscore the data
    [trainfeats, mu, sigma] = zscore(trainfeats);

    testfeats = (testfeats - repmat(mu, [size(testfeats,1),1])) ./ repmat(sigma, [size(testfeats,1),1]);
    
    predlabels = classifier(trainfeats, trainlabels, testfeats);
    
    for j = 1:length(predlabels)
        confmat(testlabels(j), predlabels(j), i) = confmat(testlabels(j), predlabels(j), i) + 1;
    end

end


end

