function [ cellfeat, nucfeat ] = cell2objfeat( img )
%takes a trinary image

imcell = img>0;
imdna = img>1;

objs = ml_3dfindobj(imcell);
[~, ind] = max(cellfun(@(x) size(x.voxels,2), objs));
cellfeat = ml_objfeat3d_noDNA(objs(ind), [], size(imcell));

cell_surfacearea = bwperim(imcell, 18);
cell_surfacearea = sum(cell_surfacearea(:));

objs = ml_3dfindobj(imdna);
[~, ind] = max(cellfun(@(x) size(x.voxels,2), objs));
nucfeat = ml_objfeat3d_noDNA(objs(ind), [], size(imdna));

dna_surfacearea = bwperim(imdna, 18);
dna_surfacearea = sum(dna_surfacearea(:));


cellfeat  = [cellfeat(:,[1 4 6 7 8 9 11]) pc12_cylindricity(imcell), cell_surfacearea];
nucfeat = [nucfeat(:,[1 4 6 7 8 9 11]) pc12_cylindricity(imdna), dna_surfacearea];



end

