function [ cylin ] = pc12_cylindricity( bwImg )
%surface area of the object under the area of a tube of the same volume

bwImg = double(logical(bwImg));

inds = find(sum(sum(bwImg,1),2));

imHeight = inds(end) - inds(1)+1;

vol = sum(bwImg(:));

%Find the radius of the cyliner
%   vol = pi * r^2 * height
%To solve for r
%   r^2 = vol / (pi * height)
%   r = (vol / (pi * height)) ^ (1/2)

radius = sqrt(vol / (pi * imHeight));

circPerim = bwperim(fspecial('disk', round(radius)) > 0 );

surfArea = sum(circPerim(:)) * imHeight;
imArea = pc12_img2perim(bwImg);
imArea = sum(imArea(:));

cylin = surfArea /  imArea;

end

