function img2slml_bbbc021_cell(shapespacedir, build)
% Generates the MCF7 cell shape model
% from G. R. Johnson, T. E. Buck,D. P. Sullivan, G. K. Rohde, and 
% R. F. Murphy (2015) Joint modeling of cell and nuclear shape variation. 
% Molecular Biology of the Cell,
% http://murphylab.web.cmu.edu/software/2015_MBoC_Cell_And_Nuclear_Shape/index.html
%
% Author: Gregory R. Johnson (gj@cs.cmu.edu)
% Created: July 7, 2015
% Nov 2, 2015 - added header block - gj@cs.cmu.edu


if ~exist('shapespacedir', 'var') | isempty(shapespacedir)
    shapespacedir = [];
end

if ~exist('build', 'var') | isempty(build)
    build = false;
end

bbbc021setup_sub

param.model.diffeomorphic.useCurrentResults = false;

param.model.diffeomorphic.shape_to_model = 'cell';
param.tempparent = 'temp_cell';
param.model.filename = 'cellModel_cell.mat';

param.model.diffeomorphic.com_align = 'body';

% param.model.diffeomorphic.distances_computed_before_saving = 200;

if build
    param.model.diffeomorphic.useCurrentResults = true;

    param.model.diffeomorphic.embedding.method = 'regress landmark';
    param.model.diffeomorphic.embedding.weighted = false;
end

rng()

model = img2slml(dimensionality, im_dna, im_cell, [], param);

% save(settingsfile);


