function [scriptsavedir] = lc_runscript(scriptpath, scriptsaveparent, njobs, args)
%Helper function to make bash scripts to run a particular matlab script 

if ~exist(scriptpath, 'file')
    disp(['Could not find ' scriptpath])
    disp('Quitting.')
end

if ~exist('njobs', 'var')
    njobs = 50;
end

if ~exist('args', 'var')
    args = [];
end


matlabPath = '/usr/local/bin/matlab_7.13';
matlabPath = '/opt/matlab/8.1/bin/matlab';

shellFiles = {};

tokens = regexp(scriptpath, filesep);
scriptname = scriptpath(tokens(end)+1:end-2);
scriptdir = scriptpath(1:tokens(end));

scriptsavedir = [scriptsaveparent filesep scriptname];

if ~exist(scriptsavedir, 'dir')
    mkdir(scriptsavedir)
end

for i = 1:njobs
    filename = [scriptname '_' num2str(i)];

    shellfile = [scriptsavedir filesep filename '.sh'];

    shellFile = fopen(shellfile,'w');
    fprintf(shellFile, [matlabPath ' -r "addpath(''' scriptdir ''') ; ' scriptname '(' args ')'  '; exit;"']);  
    fclose(shellFile);
    
end



end

