
% parentdir = '/Volumes/Data/Documents/Murphylab/projects/shapeSpace/BBBC021';


segdir = [parentdir filesep 'seg_v2'];

if ~exist(segdir, 'dir')
    mkdir(segdir)
end

load([parentdir filesep 'images' filesep 'dat.mat']);


minsize_dna = 250;
maxsize_dna = 2500;

minsize_cell = minsize_dna * 3;
maxsize_cell = 19000;

for i = 1:length(imgs_dapi)
    segfile{i} = [segdir filesep 'imseg' num2str(i) '.mat'];
    
    segfile{i}
    
    [can_start, final_name, final_exists, temp_name] = chunk_start( segfile{i}, []);
    
    if can_start
        
        if exist(segfile{i}, 'file')
            load(segfile{i})
        else
            im_dapi = imread([img_save_dir filesep imgs_suffix{i} filesep imgs_dapi{i}]);
            im_actin = imread([img_save_dir filesep imgs_suffix{i} filesep imgs_actin{i}]);
            im_tub = imread([img_save_dir filesep imgs_suffix{i} filesep imgs_tub{i}]);

            [dnamask, cellmask] = segCells_v2(im_dapi, im_actin, im_tub);
        end
        
        dnalabel = bwlabel(dnamask>0);
        a = regionprops(dnalabel,dnalabel, 'Area', 'MeanIntensity');

        area = [a.Area];
        id = [a.MeanIntensity];

        dnamask_legal = zeros(size(dnamask));
        dnamask_illegal = zeros(size(dnamask));
        
        dnamask_legal(ismember(dnalabel,id(((minsize_dna < area)) & (area < maxsize_dna)))) = 1;
        dnamask_illegal(~ismember(dnalabel,id(((minsize_dna < area)) & (area < maxsize_dna))) & (dnamask ~= 0)) = 1;
        
        dnamask(dnamask_legal > 0) = 2;
        dnamask(dnamask_illegal > 0) = 1;
        
        
        celllabel = bwlabel(cellmask>0);
        a = regionprops(celllabel, celllabel, 'Area', 'MeanIntensity');

        area_cell = [a.Area];
        id = [a.MeanIntensity];
        
        cellmask_legal = zeros(size(dnamask));
        cellmask_illegal = zeros(size(dnamask));
        
        cellmask_legal(ismember(celllabel, id((minsize_cell < area_cell) & (area_cell < maxsize_cell)))) = 1;
        cellmask_illegal(~ismember(celllabel,id(((minsize_cell < area_cell)) & (area_cell < maxsize_cell))) & (cellmask ~= 0)) = 1;
        
        cellmask(cellmask_legal > 0) = 2;
        cellmask(cellmask_illegal > 0) = 1;
        
        if any(area_cell > maxsize_cell)
            1;
        end
        
        save(segfile{i}, 'dnamask', 'cellmask')
        
        impath = [segdir filesep 'imseg' num2str(i) '.png'];

        im_tub = mat2gray(double(adapthisteq(im_tub)));
        
        im_dapi = mat2gray(double(adapthisteq(im_dapi)));
        
        
        imwrite([im_dapi, im_tub; dnamask/2, cellmask/2], impath, 'png')

    end
end
