
bbbc021setup

searchrange = 0:0.5:3.5;
error_threshes_abs_diff = 10.^(searchrange); %linspace(1,100,10);
error_threshes_abs = 10.^(searchrange); %linspace(1,100,10); % the distance measure seems to be invariant to this parameter - grj 9/11/14


[error_threshes_abs_diff,error_threshes_abs] = meshgrid(error_threshes_abs_diff, error_threshes_abs);
models = cell(size(error_threshes_abs_diff));


[~,b,~]= unique(imgs_compound(imnum));

%take the first to images of each compound
im_dna = im_dna([b]);
im_cell = im_cell([b]);


param.model.diffeomorphic.embedding_type = 'most_complete';
tempparent = [parentdir filesep 'temp_conv_abs_err'];
param.tempparent = tempparent;

for i = 1:length(error_threshes_abs_diff(:))
        
        modelsuffix = [num2str(i)];
        tempdir = [param.tempparent filesep 'diffeomorphic' modelsuffix];
       
        param.model.diffeomorphic.tempdir = tempdir;
        param.model.diffeomorphic.convergence_absolute_error_difference = error_threshes_abs_diff(i);
        param.model.diffeomorphic.convergence_absolute_error = error_threshes_abs(i);
        
        param.model.filename = [parentdir filesep 'model' modelsuffix];
        
        success = img2slml( dimensionality, im_dna, im_cell, [], param );
        
        load(param.model.filename);
        models{i} = model;
%         load([tempdir filesep 'distances' filesep '1_2.mat'])
        
%         rs{i} = r;
end

pos_best = cmdscale(models{1}.cellShapeModel.distances_incomplete);
d = zeros(size(error_threshes_abs_diff));
d(1) = 0;
for i = 2:length(models(:))
    pos_temp = pos_best;
    pos_model = cmdscale(models{i}.cellShapeModel.distances_incomplete);
    coord_diff = size(pos_temp,2) - size(pos_model,2);
    if coord_diff < 0
        pos_temp = padarray(pos_temp, [0,abs(coord_diff)],'post');
    else
        pos_model = padarray(pos_model, [0,abs(coord_diff)],'post');
    end
    d(i) = procrustes(pos_temp, pos_model);
end

surf(log10(error_threshes_abs_diff), log10(error_threshes_abs), d)
xlabel('log_1_0 error threshes abs diff')
ylabel('log_1_0 error threshes abs');
zlabel('Error from best model')

hold on
scatter(log10(5), log10(5))
