
% 
% load('gmmfit.mat')

% load('helamodel.mat')


p = model.cellShapeModel.positions;

rminds = any(isnan(p),2);

pos = p(~rminds,1:2);

c = 1;
gmmfitfile = ['gmmfit_devindemo.mat'];  
if ~exist(gmmfitfile, 'file')
    objgmm = {};
    while c < 3
        tryagain = 0;
        while tryagain < 2
            try
                objgmm{c} = gmdistribution.fit(pos,c, 'replicates', 200);
                break
            catch
                tryagain = tryagain + 1;    
            end
        end
        c = c+1;
    end
    save(gmmfitfile, 'objgmm')
else
    load(gmmfitfile)
end


[~, aicind] = min(cellfun(@(x) x.AIC, objgmm));
[~, bicind] = min(cellfun(@(x) x.BIC, objgmm));

gmm_aic = objgmm{aicind};
gmm_bic = objgmm{bicind};



tri = delaunay(pos);

linx = linspace(min(pos(:,1)), max(pos(:,1)), 200);
liny = linspace(min(pos(:,2)), max(pos(:,2)), 200);

[x,y] = meshgrid(linx,liny);

for j = 1:length(objgmm)
    for i = 1:length(x(:))
        gmm_pdf(i,j) = objgmm{j}.pdf([x(i), y(i)]);
    end
end

figure('color', 'k')
axis('tight')

scatter(x(:), y(:), 800, gmm_pdf(:,1), '.')
hold on

scatter(pos(:,1), pos(:,2), 800, '.', 'k')
triplot(tri, pos(:,1), pos(:,2), 'k')
saveas(gcf, '~/Desktop/devingmmdemo.png', 'png')


positions = nan(size(model.cellShapeModel.positions));
positions(~rminds,:) = pos;


model.cellShapeModel.positions = pos;
model.nuclearShapeModel.positions = pos;
model.cellShapeModel.tessellation = tri;
model.nuclearShapeModel.tessellation = tri;

numimgs = 5;
for i = 1:numimgs
    %sample from the gmm ANDed to the convex hull of the triangulation
    simplex_idx = nan;
    while isnan(simplex_idx)
        point = gmm_aic.random;
        simplex_idx = tsearchn(model.cellShapeModel.positions,model.cellShapeModel.tessellation,point);
    end
    points(i,:) = point;
    
    param.position = point;
    
    
    savedir = [scriptpath '_img' num2str(i)];
    if ~exist(savedir, 'dir')
        mkdir(savedir)
    end
    cd(savedir);
    
    param.targetDirectory = [scriptname filesep 'img' num2str(i)];
    
    imgs{i} = model2img({model}, param);
end



