function [ perimImg ] = pc12_img2perim( img, incTB)
%PC12_IMG2PERIM Summary of this function goes here
%   Detailed explanation goes here

if ~exist('incTB', 'var')
    incTB = false;
end

perimImg = zeros(size(img));

for i = 1:size(img,3)
    
    slice = img(:,:,i);
    
    perim = bwperim(slice);
    
    if incTB
        tPerim = zeros(size(perim));
        bPerim = zeros(size(perim));
        
        if i ~= 1
            tPerim = slice & ~img(:,:,i-1);
        end
        
        if i ~= size(img,3)
            bPerim = slice & ~img(:,:,i+1);
        end
        
        perim = perim | tPerim | bPerim;
    end
    
    perimImg(:,:,i) = perim;
end

