function [dice_pval, dice_pred, missing_perm] = dig_index(model, model_shape_inds, pred_framefiles, perm_framefiles, index_method)

if isempty(model_shape_inds)
    model_shape_inds = 1:length(pred_framefiles);
end

dice_pval = nan(size(pred_framefiles));
missing_perm = nan(size(pred_framefiles));

for i = 1:length(pred_framefiles)
    disp([num2str(i) filesep num2str(length(pred_framefiles))]);
    
    img = model.cellShapeModel.imfunc(model_shape_inds(i));
    
    img_perm = frame2img(pred_framefiles{i});
    
    dice_pred = index_method(img, img_perm);
    
    
    
    [u_perm_framefiles, ~, perm_framefiles_inds] = unique(perm_framefiles{i});
    dice_perm = nan(size(u_perm_framefiles));
    
    dice_perm_all = nan(size(perm_framefiles{i}));
    for j = 1:length(u_perm_framefiles)
        if ~exist(u_perm_framefiles{j}, 'file')
            continue;
        end
        
        img_perm = frame2img(u_perm_framefiles{j});
        dice_perm(j) = index_method(img, img_perm);
    end
    
    dice_perm_all(:) = dice_perm(perm_framefiles_inds);
    
    rminds = isnan(dice_perm_all);
    dice_perm_all(rminds) = [];
    
    missing_perm(i) = sum(rminds);
    
    dice_pval(i) = mean(dice_pred <= dice_perm_all);
end





end

function img = frame2img(framefile)
    load(framefile)
    img = round(frame.interpolated_image.get_data);
end

