
function [index_pval, index_pred, index_dists] = index_sig2(model, model_shape_inds, pred_framefiles, index_method, savedir)

if ~exist(savedir, 'dir')
    mkdir(savedir)
end

if isempty(model_shape_inds)
    model_shape_inds = 1:length(pred_framefiles);
end

index_dists = nan(length(model_shape_inds));

for i = 1:length(model_shape_inds)
    disp([num2str(i) filesep num2str(length(model_shape_inds))]);
    
    dists_file = [savedir filesep 'd' num2str(i) '.mat'];
    tmpfile = [dists_file '.tmp'];
    
    if ~exist(dists_file, 'file') && ~exist(tmpfile, 'file')
        system(['touch ' tmpfile]);
        
        dists = nan(1, length(model_shape_inds));
        
        for j = i+1:length(model_shape_inds)
            dists(j) = index_method(model.cellShapeModel.imfunc(model_shape_inds(i)), model.cellShapeModel.imfunc(model_shape_inds(j)));
        end
        save(dists_file, 'dists'); 
        
        system(['rm ' tmpfile]);
        
    elseif exist(dists_file, 'file') && ~exist(tmpfile, 'file')
        load(dists_file)
    else
        continue
    end
    index_dists(i,i+1:end) = dists(i+1:end);
    index_dists(i+1:end,i) = dists(i+1:end);
end

index_dists(logical(eye(size(index_dists)))) = 1;

index_pred = zeros(length(model_shape_inds),1);
for i = 1:length(pred_framefiles)
    index_pred(i) = index_method(model.cellShapeModel.imfunc(model_shape_inds(i)), frame2img(pred_framefiles{i}));
end


further_than = repmat(index_pred, [1, size(index_dists,2)]) <= index_dists;
further_than(logical(eye(size(further_than)))) = 0;

index_pval = (sum(further_than,2) + eps)./(size(further_than,2)-1 + eps);



end



