function  pred_img_saver(cellmodel, nucmodel, nuc2cell_framefiles, cell2nuc_framefiles, imfunc_inds, frame_inds, prefix, synth_img_dir )

for i = 1:length(frame_inds)
    cell_shape = [cellmodel.model.cellShapeModel.imfunc(imfunc_inds(i)) frame2img(nuc2cell_framefiles{frame_inds(i)})];
    nuc_shape = [nucmodel.model.cellShapeModel.imfunc(imfunc_inds(i)) frame2img(cell2nuc_framefiles{frame_inds(i)})];

    cell_diff = cellmodel.model.cellShapeModel.imfunc(imfunc_inds(i))~= frame2img(nuc2cell_framefiles{frame_inds(i)});
    nuc_diff = nucmodel.model.cellShapeModel.imfunc(imfunc_inds(i)) ~= frame2img(cell2nuc_framefiles{frame_inds(i)});

    if size(cell_shape,3) == 1;
        cell_shape = cell_shape.*255;
        nuc_shape = nuc_shape.*255;
        cell_diff = cell_diff.*255;
        nuc_diff = nuc_diff.*255;
    else
        cell_shape = im2projection_RGB(cell_shape)*1.5;
        nuc_shape = im2projection_RGB(nuc_shape)*1.5;
        cell_diff = im2projection_RGB(cell_diff)*1.5;
        nuc_diff = im2projection_RGB(nuc_diff)*1.5;
    end

    imwrite(cell_shape, [synth_img_dir filesep prefix '_cell_' num2str(i) '.png'], 'png')
    imwrite(nuc_shape, [synth_img_dir filesep prefix '_nuc_' num2str(i) '.png'], 'png')

    imwrite(cell_diff, [synth_img_dir filesep prefix '_cell_' num2str(i) '_diff.png'], 'png')
    imwrite(nuc_diff, [synth_img_dir filesep prefix '_nuc_' num2str(i) '_diff.png'], 'png')
end

end

