function [pval, norm_error, norm_error_cb] = pval_dist_all(errors, error_distr)

errors = errors.^2;
error_distr = error_distr.^2;

ndat = length(errors);

niter = 10000;

inds = randi(ndat, [ndat, niter]);

synth_error = nan([ndat, niter]);

for i = 1:ndat
    synth_error(i,:) = error_distr(i,inds(i,:));
end

pval = mean([sum(errors) >= sum(synth_error,1) 1]);

mean_null_error = mean(sum(synth_error,1));
% norm_error = sum(errors)./mean_null_error;

[norm_error_cb, stat] = bootci(10000, @(x) sum(x)/mean_null_error, errors);

norm_error = sum(errors);

% pval = mean(synth_error,2);
