function pred_table =  save_pred_dat2(cell2nuc, nuc2cell, cell2nuc_pvals, nuc2cell_pvals, ucond, object_info, saveparent, suffix)

if ~exist('suffix', 'var')
    suffix = [];
end

if ~isempty(suffix) && ~strcmp(suffix(1), '_')
    suffix = ['_' suffix];
end

if ~exist(saveparent, 'dir')
    mkdir(saveparent);
end

tot_num_cells =                 cellfun(@(x) length(x.y_pred_err),                  nuc2cell);

nuc2cell_avg_kernel_size =  cellfun(@(x) mean(x.k_x2y),                         nuc2cell);
nuc2cell_std_kernel_size =  cellfun(@(x) std(x.k_x2y),                          nuc2cell);
nuc2cell_avg_err =          cellfun(@(x) mean(x.y_pred_err),                    nuc2cell);
nuc2cell_std_err =          cellfun(@(x) std(x.y_pred_err),                     nuc2cell);
nuc2cell_avg_norm_err =     cellfun(@(x) mean(x.y_norm_err),                    nuc2cell);
nuc2cell_std_norm_err =     cellfun(@(x) std(x.y_norm_err),                     nuc2cell);
nuc2cell_avg_pval =         cellfun(@(x) mean(x.y_pval),                        nuc2cell);
nuc2cell_std_pval =         cellfun(@(x) std(x.y_pval),                         nuc2cell);

nuc2cell_model_pred_err =   cellfun(@(x) x.y_model_err,                         nuc2cell);
nuc2cell_model_pred_pval =  cellfun(@(x) x.y_model_pval,                        nuc2cell);




% if ~isfield(nuc2cell{1}, 'y_dists')
%     nuc2cell_mse_norm =     nuc2cell_avg_err ./ cellfun(@(x) mean(pdist(x.x)),      nuc2cell);
% else
%     nuc2cell_mse_norm =     nuc2cell_avg_err ./ cellfun(@(x) mean(x.y_dists(logical(triu(x.y_dists,1)))), nuc2cell);
% end


% nuc2cell_tot_stat_sig =     cellfun(@(x) sum(x.y_pval < 0.05),                  nuc2cell);
% nuc2cell_fract_stat_sig =   cellfun(@(x) mean(x.y_pval < 0.05),                 nuc2cell);
% nuc2cell_std_pred_pval =    cellfun(@(x) std(x.y_pval),                         nuc2cell);
% nuc2cell_median_pval =      cellfun(@(x) median(x.y_pval),                      nuc2cell);



cell2nuc_avg_kernel_size =  cellfun(@(x) mean(x.k_x2y),                         cell2nuc);
cell2nuc_std_kernel_size =  cellfun(@(x) std(x.k_x2y),                          cell2nuc);
cell2nuc_avg_err =          cellfun(@(x) mean(x.y_pred_err),                    cell2nuc);
cell2nuc_std_err =          cellfun(@(x) std(x.y_pred_err),                     cell2nuc);
cell2nuc_avg_norm_err =     cellfun(@(x) mean(x.y_norm_err),                    cell2nuc);
cell2nuc_std_norm_err =     cellfun(@(x) std(x.y_norm_err),                     cell2nuc);
cell2nuc_avg_pval =         cellfun(@(x) mean(x.y_pval),                        cell2nuc);
cell2nuc_std_pval =         cellfun(@(x) std(x.y_pval),                         cell2nuc);

cell2nuc_model_pred_err =   cellfun(@(x) x.y_model_err,                         cell2nuc);
cell2nuc_model_pred_pval =  cellfun(@(x) x.y_model_pval,                        cell2nuc);

% if ~isfield(nuc2cell{1}, 'y_dists')
%     cell2nuc_mse_norm =         cell2nuc_mse ./ cellfun(@(x) mean(pdist(x.x)),      cell2nuc);
% else
%     cell2nuc_mse_norm =     cell2nuc_mse ./ cellfun(@(x) mean(x.y_dists(logical(triu(x.y_dists,1)))), cell2nuc);
% end

% cell2nuc_tot_stat_sig =     cellfun(@(x) sum(x.y_pval < 0.05),                  cell2nuc);
% cell2nuc_fract_stat_sig =   cellfun(@(x) mean(x.y_pval < 0.05),                 cell2nuc);
% cell2nuc_avg_pval =         cellfun(@(x) mean(x.y_pval),                        cell2nuc);
% cell2nuc_median_pval =      cellfun(@(x) median(x.y_pval),                      cell2nuc);

nuc2cell_model_err_over_cell2nuc_model_err = nuc2cell_model_pred_err./cell2nuc_model_pred_err;
nuc2cell_model_err_over_cell2nuc_model_err_norm = nuc2cell_avg_norm_err./cell2nuc_avg_norm_err;

% median_nuc2cell_over_cell2nuc_pval = cellfun(@(x,y) median(x.y_pval./y.y_pval),                       nuc2cell, cell2nuc);

% std_err_nuc2cell_over_cell2nuc_pval = cellfun(@(x,y) std(x.y_pval./y.y_pval)/length(y.y_pval),                       nuc2cell, cell2nuc);

% log10_pval_ratio = nuc2cell_log10_pval-cell2nuc_log10_pval;

var_names = {'conditions', 'tot_num_cells', ...
             'avg_kernel_size_nuc2cell', 'std_kernel_size_nuc2cell', 'avg_err_nuc2cell', 'std_err_nuc2cell', 'norm_avg_err_nuc2cell', 'norm_std_err_nuc2cell', 'avg_pval_nuc2cell', 'std_pval_nuc2cell', 'model_pred_err_nuc2cell', 'model_pval_nuc2cell', ...
             'avg_kernel_size_cell2nuc', 'std_kernel_size_cell2nuc', 'avg_err_cell2nuc', 'std_err_cell2nuc', 'norm_avg_err_cell2nuc', 'norm_std_err_cell2nuc', 'avg_pval_cell2nuc', 'std_pval_cell2nuc', 'model_pred_err_cell2nuc', 'model_pval_cell2nuc', ...
             'nuc2cell_model_err_over_cell2nuc_model_err', 'nuc2cell_model_err_over_cell2nuc_model_err_norm'};
             
% var_names = {'conditions', 'tot_num_cells', ...
%              'nuc2cell_avg_kernel_size', 'nuc2cell_std_kernel_size', 'MSE_nuc2cell', 'MSE_nuc2cell_normalized', 'nuc2cell_tot_stat_sig', 'nuc2cell_fract_stat_sig', 'nuc2cell_avg_pval', 'nuc2cell_median_pval', ...% 'nuc2cell_num_perms', ...
%              'cell2nuc_avg_kernel_size', 'cell2nuc_std_kernel_size', 'MSE_cell2nuc', 'MSE_cell2nuc_normalized', 'cell2nuc_tot_stat_sig', 'cell2nuc_fract_stat_sig', 'cell2nuc_avg_pval', 'cell2nuc_median_pval',...%'cell2nuc_num_perms', ...
%              'avg_nuc2cell_over_cell2nuc_pval', 'std_err_nuc2cell_over_cell2nuc_pval', 'median_nuc2cell_over_cell2nuc_pval'};
         
if ~exist('object_info', 'var') || isempty(object_info)
    row_names = cellstr(num2str((1:length(cell2nuc))'))';
else
    row_names = object_info.condition_names;
end

pred_table = table(ucond', tot_num_cells', ...
                   nuc2cell_avg_kernel_size', nuc2cell_std_kernel_size', nuc2cell_avg_err', nuc2cell_std_err', nuc2cell_avg_norm_err', nuc2cell_std_norm_err', nuc2cell_avg_pval', nuc2cell_std_pval', nuc2cell_model_pred_err', nuc2cell_model_pred_pval', ...
                   cell2nuc_avg_kernel_size', cell2nuc_std_kernel_size', cell2nuc_avg_err', cell2nuc_std_err', cell2nuc_avg_norm_err', cell2nuc_std_norm_err', cell2nuc_avg_pval', cell2nuc_std_pval', cell2nuc_model_pred_err', cell2nuc_model_pred_pval', ...
                   nuc2cell_model_err_over_cell2nuc_model_err', nuc2cell_model_err_over_cell2nuc_model_err_norm', ...
                   'VariableNames', var_names, 'RowNames', row_names');
               
pred_table_path = [saveparent filesep 'pred_table' suffix '.csv'];
writetable(pred_table, pred_table_path, 'WriteRowNames', true);

var_names_short = {'conditions', 'tot_num_cells', ...
                    'model_pred_err_nuc2cell', 'model_pval_nuc2cell', ...
                    'model_pred_err_cell2nuc', 'model_pval_cell2nuc'
                    };
                
pred_table_short = table(ucond', tot_num_cells', ...
                        nuc2cell_model_pred_err', nuc2cell_model_pred_pval', ...
                        nuc2cell_model_pred_pval', cell2nuc_model_pred_pval', ...
                        'VariableNames', var_names_short, 'RowNames', row_names');
pred_table_short_path = [saveparent filesep 'pred_table_short' suffix '.csv'];
writetable(pred_table_short, pred_table_short_path, 'WriteRowNames', true)
                    


colors = jet(length(ucond));

% pval_vs_mse_alldat_fig = [saveparent filesep 'pval_vs_mse_alldat_cell_and_nuc' suffix '.tif'];
% 
% figure, 
% for i = 1:length(cell2nuc)
%     scatter(nuc2cell_mse_norm(i), nuc2cell_fract_stat_sig(i), 300, colors(i,:), '*')
%     hold on
%     scatter(cell2nuc_mse_norm(i), cell2nuc_fract_stat_sig(i), 300, colors(i,:), '.')
% end
% xlabel('Normalized MSE')
% ylabel('% statistically significant predicitons')
% saveas(gcf, pval_vs_mse_alldat_fig, 'tif')
% close(gcf)


% 
% pval_vs_mse_alldat_fig = [saveparent filesep 'pval_vs_mse_alldat_cell_given_nuc' suffix '.tif'];
% 
% figure, 
% for i = 1:length(cell2nuc)
%     scatter(nuc2cell_mse_norm(i), nuc2cell_fract_stat_sig(i), 300, colors(i,:), '.')
%     hold on
% end
% xlabel('Normalized MSE')
% ylabel('% statistically significant predicitons')
% saveas(gcf, pval_vs_mse_alldat_fig, 'tif')
% close(gcf)

% 
% pval_vs_mse_alldat_fig = [saveparent filesep 'pval_vs_mse_alldat_nuc_given_cell' suffix '.tif'];
% 
% figure, 
% for i = 1:length(cell2nuc)
%     scatter(cell2nuc_mse_norm(i), cell2nuc_fract_stat_sig(i), 300, colors(i,:), '.')
%      hold on
% end
% xlabel('Normalized MSE')
% ylabel('% statistically significant predicitons')
% saveas(gcf, pval_vs_mse_alldat_fig, 'tif')
% close(gcf)



pval_vs_mse_percell_fig = [saveparent filesep 'pval_vs_mse_percell' suffix '.tif'];

figure,
for i = 1:length(nuc2cell)
    scatter(log10(cell2nuc{i}.y_pred_err), cell2nuc{i}.y_pval, 50, colors(i,:), 'x')
    hold on
    scatter(log10(nuc2cell{i}.y_pred_err), nuc2cell{i}.y_pval, 100, colors(i,:), '.')
end
xlabel('log10(Predicted position MSE)')
ylabel('P-value')
saveas(gcf, pval_vs_mse_percell_fig, 'tif')
close(gcf)

pval_vs_pval_percell_fig = [saveparent filesep 'pval_vs_pval_percell' suffix '.tif'];
figure, 
for i = 1:length(nuc2cell)
    scatter(cell2nuc{i}.y_pval, nuc2cell{i}.y_pval, 50, colors(i,:), '.')
    hold on
end
xlabel('nuc pval')
ylabel('cell pval')
saveas(gcf, pval_vs_pval_percell_fig, 'tif')
close(gcf)


err_vs_err_percell_fig = [saveparent filesep 'err_norm_vs_err_norm_percell' suffix '.tif'];
figure, 
for i = 1:length(nuc2cell)
    scatter(cell2nuc{i}.y_norm_err, nuc2cell{i}.y_norm_err, 50, colors(i,:), '.')
    hold on
end
xlabel('nuc err')
ylabel('cell err')
axis([0,1.25, 0, 1.25])
saveas(gcf, err_vs_err_percell_fig, 'tif')
close(gcf)




for i = 1:length(ucond)
    nuc2cell_err_norm{i} = nuc2cell{i}.y_norm_err;
    cell2nuc_err_norm{i} = cell2nuc{i}.y_norm_err;
    
    class{i} = ones(size(nuc2cell{i}.y_norm_err)).*i;
end

nuc2cell_err_norm = vertcat(nuc2cell_err_norm{:});
cell2nuc_err_norm = vertcat(cell2nuc_err_norm{:});
class = vertcat(class{:});



if length(unique(class)) > 1
 
    err_fig_file = [saveparent filesep 'cell_nuc_err' suffix '.tif'];
    err_fig_file_legend = [saveparent filesep 'cell_nuc_err_legend' suffix '.tif'];
    [~,~,stats_c2n,~]  = anovan(cell2nuc_err_norm, class, 'model', 'interaction', 'display', 'off');
    [~,~,stats_n2c,~]  = anovan(nuc2cell_err_norm, class, 'model', 'interaction', 'display', 'off');

    [c2n_diffs,c2n_m,~,~, c2n_hw] = multcompare2(stats_c2n, 'dimension', 1, 'display', 'off', 'ctype', 'hsd');
    [n2c_diffs,n2c_m,~,~, n2c_hw] = multcompare2(stats_n2c, 'dimension', 1, 'display', 'off', 'ctype', 'hsd');

    c2n_std = c2n_m(:,2);
    c2n_m = c2n_m(:,1);

    n2c_std = n2c_m(:,2);
    n2c_m = n2c_m(:,1);

    figure,
    colors = jet(length(ucond))*0.8;
   
    % Change to new colors.
    set(gca, 'ColorOrder', colors, 'NextPlot', 'replacechildren');
             
                

    
    plot([c2n_m-c2n_hw c2n_m+c2n_hw]', repmat(n2c_m',[2,1]), 'LineWidth', 2), hold on    
    plot(repmat(c2n_m',[2,1]), [n2c_m-n2c_hw n2c_m+n2c_hw]', 'LineWidth', 2)
    scatter(c2n_m, n2c_m, 200, colors, '.')
    xlabel('Average nuclear shape prediction error', 'fontsize', 6)
    ylabel('Average cell shape prediction error', 'fontsize', 6)
    
    set(get(gcf, 'CurrentAxes'),'position',[0.12, 0.10, 0.85, 0.85],'units','normalized')
    set(gcf, 'PaperUnits', 'Inches', 'PaperSize', [3.33, 3.33] )
    
    set(gca, 'FontSize', 6)
    
    axis equal
    
    print(err_fig_file, gcf, '-dtiff', '-r600')
    
    ucond_short = regexp(ucond, ' - ', 'split');
    ucond_short = vertcat(ucond_short{:});
    ucond_short = ucond_short(:,1);
    
    legend(gca, ucond_short)
    print(err_fig_file_legend, gcf, '-dtiff', '-r600')
    
    close(gcf)

    c2n_pvals = zeros(length(ucond));
    n2c_pvals = zeros(length(ucond));
    
    for i = 1:size(c2n_diffs,1)
        c2n_pvals(c2n_diffs(i,1), c2n_diffs(i,2)) = c2n_diffs(i,6);
        n2c_pvals(n2c_diffs(i,1), n2c_diffs(i,2)) = n2c_diffs(i,6);
    end
    c2n_pvals = c2n_pvals+c2n_pvals';
    n2c_pvals = n2c_pvals+n2c_pvals';
    
    c2n_pval_thresh = double(c2n_pvals < 0.05);
    c2n_pval_thresh(logical(eye(size(c2n_pval_thresh)))) = nan;
    n2c_pval_thresh = double(n2c_pvals < 0.05);
    n2c_pval_thresh(logical(eye(size(n2c_pval_thresh)))) = nan;
    
    matsize = ones(1,length(ucond));
    c2n_pvals = mat2cell(c2n_pvals, matsize, matsize);
    n2c_pvals = mat2cell(n2c_pvals, matsize, matsize);
    c2n_pval_thresh = mat2cell(c2n_pval_thresh, matsize, matsize);
    n2c_pval_thresh = mat2cell(n2c_pval_thresh, matsize, matsize);
    
    pvals = [c2n_pvals cell(length(ucond),1) n2c_pvals];
    pvals_thresh = [c2n_pval_thresh cell(length(ucond),1) n2c_pval_thresh];
    
    pvals_all = [pvals; cell(1, size(pvals,2)); pvals_thresh];
    
    var_names_c2n = cellfun(@(x) ['pred_nuc_err_' x], ucond, 'UniformOutput', false);
    var_names_n2c = cellfun(@(x) ['pred_cell_err_' x], ucond, 'UniformOutput', false);
    varnames = [var_names_c2n, {'space'}, var_names_n2c];
    
    varnames = strrep(varnames, ' ', '_');
    varnames = strrep(varnames, '-', '_');
    
    error_diff_table = array2table(pvals_all, 'variableNames', varnames);
    error_diff_table_path = [saveparent filesep 'err_difference_table' suffix '.csv'];
    writetable(error_diff_table, error_diff_table_path, 'WriteRowNames', true)

    for i = 1:length(ucond)
        [~,~,stats_n2c,~]  = anovan(nuc2cell_err_norm, double(class == i), 'model', 'interaction', 'display', 'off');
        [~,~,stats_c2n,~]  = anovan(cell2nuc_err_norm, double(class == i), 'model', 'interaction', 'display', 'off');

        [c2n_diffs,c2n_m,~,~, c2n_hw] = multcompare2(stats_c2n, 'dimension', 1, 'display', 'off', 'ctype', 'hsd');
        [n2c_diffs,n2c_m,~,~, n2c_hw] = multcompare2(stats_n2c, 'dimension', 1, 'display', 'off', 'ctype', 'hsd');
        
        diff_vs_mean(i,:) = [mean(nuc2cell_err_norm(class==i)), -n2c_diffs(1,4), n2c_diffs(1,6), n2c_diffs(1,6)< 0.05, mean(cell2nuc_err_norm(class==i)), -c2n_diffs(1,4), c2n_diffs(1,6), c2n_diffs(1,6)< 0.05];
    end
    
    error_vs_mean_table_path = [saveparent filesep 'error_vs_mean_table' suffix '.csv'];
    error_vs_mean_table = array2table(diff_vs_mean, 'variableNames', {'avg_cell_error', 'cell_err_difference_from_mean', 'cell_err_p_val_vs_mean', 'cell_err_p_val_vs_mean_stat_sig', 'avg_nuc_error','nuc_err_difference_from_mean',  'nuc_err_p_val_vs_mean', 'nuc_err_p_val_vs_mean_stat_sig'}, 'RowNames', ucond);
    writetable(error_vs_mean_table, error_vs_mean_table_path, 'WriteRowNames', true)
    
end


ucond = 1:length(ucond);

if ~exist('object_info', 'var') || isempty(object_info)
    return;
end

for i = 1:length(ucond)
    %find the objects that correspond to this condition
    ucondinds = object_info.obj_condition == ucond(i) ;
    objinds = find(ismember(object_info.transition_obj_inds(:,1), find(ucondinds)));

%     objinds = objinds(all(~ismember(object_info.transition_obj_inds(objinds,:), naninds),2));

    obj_inds0 = object_info.transition_obj_inds(objinds,1);
    obj_inds1 = object_info.transition_obj_inds(objinds,2);
    
    
    
    cell2nuc_pvals0 = cell2nuc_pvals(obj_inds0);
    cell2nuc_pvals1 = cell2nuc_pvals(obj_inds1);
    
    nuc2cell_pvals0 = nuc2cell_pvals(obj_inds0);
    nuc2cell_pvals1 = nuc2cell_pvals(obj_inds1);
    
    datsize = size(nuc2cell_pvals0);
    

    nuc2cell_transmat{i} = zeros(2,2);
    cell2nuc_transmat{i} = zeros(2,2);
    
%     statsig = 0.05;
    for j = 1:length(nuc2cell_pvals0)
        
        statsig = mean([nuc2cell_pvals0', nuc2cell_pvals1']);
        
        ind0 = (nuc2cell_pvals0(j) >= statsig) + 1;
        ind1 = (nuc2cell_pvals1(j) >= statsig) + 1;
        nuc2cell_transmat{i}(ind0, ind1) = nuc2cell_transmat{i}(ind0, ind1) + 1;
        
        statsig = mean([cell2nuc_pvals0', cell2nuc_pvals1']);
        
        ind0 = (cell2nuc_pvals0(j) >= statsig) + 1;
        ind1 = (cell2nuc_pvals1(j) >= statsig) + 1;
        cell2nuc_transmat{i}(ind0, ind1) = cell2nuc_transmat{i}(ind0, ind1) + 1;
    end
        
    nuc2cell_transmat_norm{i} = nuc2cell_transmat{i}./repmat(sum(nuc2cell_transmat{i},2), [1,2]);
    cell2nuc_transmat_norm{i} = cell2nuc_transmat{i}./repmat(sum(cell2nuc_transmat{i},2), [1,2]);
    
    figure,
    
    jitter = 100;
    subplot(1,2,1)
    scatter(nuc2cell_pvals0+rand(datsize)/jitter, nuc2cell_pvals1+rand(datsize)/jitter, 50, colors(i,:))
    title('nuc2cell')
    xlabel('p-value t=0')
    ylabel('p-value t=1')
    axis([0,1,0,1])
    
    subplot(1,2,2)
    scatter(cell2nuc_pvals0+rand(datsize)/jitter, cell2nuc_pvals1+rand(datsize)/jitter, 50, colors(i,:))
    title('cell2nuc')
    xlabel('p-value t=0')
    ylabel('p-value t=1')
    axis([0,1,0,1])
    
    saveas(gcf, [saveparent filesep 'transitions_' object_info.condition_names{i} suffix '.tif'], 'tif')
    close(gcf)
%     title(object_info.condition_names{i})
    
end

transmat_table_path = [saveparent filesep 'transitions_all' suffix '.csv'];


nuc2cell_transmat_table = table(nuc2cell_transmat{:}, 'VariableNames', object_info.condition_names);
nuc2cell_transmat_table_norm = table(nuc2cell_transmat_norm{:}, 'VariableNames', object_info.condition_names);

nuc2cell_transmat_table_all = vertcat(nuc2cell_transmat_table, nuc2cell_transmat_table_norm);

cell2nuc_transmat_table = table(cell2nuc_transmat{:}, 'VariableNames', object_info.condition_names);
cell2nuc_transmat_table_norm = table(cell2nuc_transmat_norm{:}, 'VariableNames', object_info.condition_names);

cell2nuc_transmat_table_all = vertcat(cell2nuc_transmat_table, cell2nuc_transmat_table_norm);

transmat_table_all = vertcat(nuc2cell_transmat_table_all, cell2nuc_transmat_table_all);


writetable(transmat_table_all, transmat_table_path)




end

