% width = 8.9;     % Width in cm
% height = 8.9;    % Height in cm
% alw = 0.75;    % AxesLineWidth
% fsz = 10;      % Fontsize
% lw = 1.5;      % LineWidth
% msz = 8;       % MarkerSize
% 
% set(0,'defaultLineLineWidth',lw);   % set the default line width to lw
% set(0,'defaultLineMarkerSize',msz); % set the default line marker size to msz
% 
% % Set the default Size for display
% defpos = get(0,'defaultFigurePosition');
% set(0,'defaultFigurePosition', [defpos(1) defpos(2) width*100, height*100]);
% 
% % Set the defaults for saving/printing to a file
% set(0,'defaultFigureInvertHardcopy','on'); % This is the default anyway
% set(0,'defaultFigurePaperUnits','centimeters'); % This is the default anyway
% defsize = get(gcf, 'PaperSize');
% left = (defsize(1)- width)/2;
% bottom = (defsize(2)- height)/2;
% defsize = [left, bottom, width, height];
% set(0, 'defaultFigurePaperPosition', defsize);
% 
% 
% 
% parentdirs = {'/Volumes/Data/Documents/Murphylab/projects/shapeSpace/', ...
%                 '/Users/Greg/Documents/murphylab/projects/shapeSpace/'};
% 
% for i = 1:length(parentdirs)
%     if exist(parentdirs{i}, 'dir')
%         parentdir = parentdirs{i};
%     end
% end

figuredir = [parentdir filesep 'figures' filesep];
addpath(genpath(figuredir));

% dir_bbbc21 = [parentdir filesep 'BBBC021' filesep];
dir_hela = [parentdir filesep 'diffeo_tub' filesep 'diffeomorphic_newesg' filesep];
% dir_c2c12 = [parentdir filesep 'c2c12' filesep];
% 

load([dir_hela filesep 'cellModel.mat']);
script_figure1_pipeline_overview(model, figuredir)
script_figure2_Hela3D; %Hela-3D hape space + simplex and interpolated shape (ray trace)
script_figure3(model, figuredir); %Graph evaluating approximatons with Hela 3D

% script_figure4; %HT29 classify based on coordinates in shape space
% script_figure5; %Color Shape by DNA content
% script_figure6; %C2C12 - Color one trace by Time gray for rest
% 
% % A. Shape-Ellipse example
% % B. Shape-Ellipse reduce 1
% script_s1;
% 
% % Approximations of fig2
% script_s2;
% 
% %Random walk movie
% %DNA intensity
% script_s3;
