function script_figure2_Hela3D( model1, model2 )
%assume the models have the same images

posinds = ~any(isnan(model1.cellShapeModel.positions),2) & ~any(isnan(model2.cellShapeModel.positions),2);

pos1 = model1.cellShapeModel.positions(posinds,:);
pos2 = model2.cellShapeModel.positions(posinds,:);

padsize = size(pos1,2) - size(pos2,2);

if padsize > 0
    pos2 = padarray(pos2, [0,padsize], 'post');
elseif padsize < 0
    pos1 = padarray(pos1, [0, padsize], 'post');
end

[~, pos2_align] = procrustes(pos1, pos2);

figure,

for i = 1:size(pos1,1)
    line([pos1(i,1), pos2_align(i,1)], [pos1(i,2), pos2_align(i,2)], 'color', 'k')
    hold on
end

model1.cellShapeModel.positions = nan(length(posinds), size(pos1,2));
model1.cellShapeModel.positions(posinds,:) = pos1;

model2.cellShapeModel.positions = nan(length(posinds), size(pos1,2));
model2.cellShapeModel.positions(posinds,:) = pos2_align;

param.subsize = 800;

param.imfunc = @(x) im2projection_RGB(model1.cellShapeModel.imfunc(x), struct('justz', true));
showShapeSpaceFigure(model1, [], param)

param.imfunc = @(x) im2projection_RGB(model2.cellShapeModel.imfunc(x), struct('justz', true));
showShapeSpaceFigure(model2, [], param)
