function [ output_args ] = script_embed_models( model )
%Demonstrates difference between weighted and unweighted embedding
figuredir = '/Users/Greg/Documents/murphylab/projects/shapeSpace/figures/'

keepinds = ~any(isnan(model.cellShapeModel.positions),2);

dmat = model.cellShapeModel.distances_incomplete(keepinds,keepinds);

param.just_positions = true;

param.weighted = false;
[result, success] = compute_shape_space(dmat, param);

model.cellShapeModel.positions = nan(model.cellShapeModel.numimgs, size(result.positions,2));
model.cellShapeModel.positions(keepinds,:) = result.positions;

figure, showShapeSpaceFigure(model, [], param);
axis([-2.5, 2.5, -2.5, 2.5])


param.weighted = true;
param.weight_factor = 2;
[result, success] = compute_shape_space(dmat, param);


model.cellShapeModel.positions = nan(model.cellShapeModel.numimgs, size(result.positions,2));
model.cellShapeModel.positions(keepinds,:) = result.positions;

param.subsize = 400;
param.imfunc = @(x) im2projection_RGB(model.cellShapeModel.imfunc(x), struct('justz', true));
figure, showShapeSpaceFigure(model, [], param);
axis([-3.5, 3, -3, 3])

% set(gca, 'color', 'k')
% set(gcf, 'color', 'k')
saveas(gcf, [figuredir filesep 'embed_weighted_1x.tif'], 'tif')

param.subsize = 200;
figure, showShapeSpaceFigure(model, [], param);
axis([-3.5, 3, -3, 3])

% set(gca, 'color', 'k')
% set(gcf, 'color', 'k')
saveas(gcf, [figuredir filesep 'embed_weighted_2x.tif'], 'tif')


param = struct();
param.subsize = 400;


figure, showShapeSpaceFigure(model, [], param);
axis([-3.5, 3, -3, 3])
% 
% set(gca, 'color', 'k')
% set(gcf, 'color', 'k')
saveas(gcf, [figuredir filesep 'embed_weighted_1x_color.tif'], 'tif')

param = struct();
param.subsize = 200;
figure, showShapeSpaceFigure(model, [], param);
axis([-3.5, 3, -3, 3])
% 
% set(gca, 'color', 'k')
% set(gcf, 'color', 'k')
saveas(gcf, [figuredir filesep 'embed_weighted_2x_color.tif'], 'tif')


model

end

