function script_figure3(model, savedir)
% Generates Figure showing the fit of shape space embeddings with varying 
% amounts of available data
% from G. R. Johnson, T. E. Buck,D. P. Sullivan, G. K. Rohde, and 
% R. F. Murphy (2015) Joint modeling of cell and nuclear shape variation. 
% Molecular Biology of the Cell,
% http://murphylab.web.cmu.edu/software/2015_MBoC_Cell_And_Nuclear_Shape/index.html
%
% Author: Gregory R. Johnson (gj@cs.cmu.edu)
% Created: Feb 28, 2015
% Nov 2, 2015 - added header block - gj@cs.cmu.edu

% Copyright (C) 2015 Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

if ~exist('model', 'var')
    
   parentdirs = {'/Volumes/Data/Documents/Murphylab/projects/shapeSpace/', ...
                '/projects/cellorganizer/gj/shapeSpace/', ...
                '/Users/Greg/Documents/murphylab/projects/shapeSpace/'};
                      
    for i = 1:length(parentdirs)
        if exist(parentdirs{i}, 'dir')
            parentdir = parentdirs{i};
            break
        end
    end
    
    addpath(genpath([parentdir '/code']))
    addpath(genpath([parentdir '/diffeo_tub/code']));
    
    load([parentdir '/diffeo_tub/diffeomorphic_newesg/cellModel.mat'])
end

if ~exist('savedir', 'var')
    savedir = [parentdir '/figures/' filesep mfilename];
end

test_reconstruction_methods(model.cellShapeModel.distances_incomplete, savedir)

end

