function [ output_args ] = script_figureS2_filter( model, parentdir )
%This generates a figure showing the difference in interpolation between
%the a high-aspect-ratio filter and a normal filter that corresponds with
%teh 

if ~exist('parentdir', 'var')
    parentdirs = {'/Volumes/Data/Documents/Murphylab/projects/shapeSpace/', ...
        '/Users/Greg/Documents/murphylab/projects/shapeSpace/'};
    
    for i = 1:length(parentdirs)
        if exist(parentdirs{i}, 'dir')
            parentdir = parentdirs{i};
        end
    end
end


filepath = which(mfilename);

filedir = filepath(1:end-(length(mfilename)+2));
cd(filedir);

figuredir = [parentdir  filesep 'figures' filesep mfilename];

param.preprocessingFolder  = figuredir;
param.train.flag = 'framework';
param.display = false;

imgparentdir = [parentdir  'diffeo_tub' filesep 'images'];
[subdirs] = getSubDirs(imgparentdir, 'cell*');
for j = 1:2
    j
    dnaimgs{j} = @() imfunc_helamodel([subdirs{j} filesep 'dna']);
    cellimgs{j} = @() imfunc_helamodel([subdirs{j} filesep 'cell']);
    maskimgs{j} = @() imfunc_helamodel([subdirs{j} filesep 'crop']);
    imgdir{j} = subdirs{j};
    
    
    [segdna,segcell] = seg_cell_and_nucleus( dnaimgs{j}, cellimgs{j}, [], [], [4.0816,4.0816,1]*2, false, param, j );
    
   
end

param.model = [];
param.model.diffeomorphic.tempdir = param.preprocessingFolder ;
param.documentation.numimgs = 2;
 
 
 imfunc = get_diffeo_image_function(param);
   


start = padarray(imfunc(1), [0,0,3],0, 'both');
last = padarray(imfunc(2), [0,0,3],0, 'both');

param

numpts = 10
pts = linspace(0,1, numpts);

lambda = pts./pts(end:-1:1);


options = model.cellShapeModel.shape_space_options;
options.window_radius = size(start,1);
options.just_compute_distance = false;


options.tempparent = param.model.diffeomorphic.tempdir;
mkdir(options.tempparent);

options.convergence_absolute_error_difference = 0.5;
options.convergence_absolute_error = 0.1;
options.convergence_registration_error = 0;

% options.filter_radius = 100;
% options.kernel_z_radius = 10;


%these settings are from train_diffeomorphic_model
 options.filter_radius = ceil(size(start,1)*0.1);
 options.kernel_z_radius = ceil(size(start,3).*0.2);
    
options.single_sided = false;

% def1 = Greedy3D_lambda_pre_compressed(...
%         start, last, lambda, options);
%     
%  options.filter_radius = ceil(size(start,3).*0.2);
%  options.kernel_z_radius = ceil(size(start,3).*0.2);
%     
%  def2 = Greedy3D_lambda_pre_compressed(...
%         start, last, lambda, options);
%     
%  options.filter_radius = ceil(size(start,1)*0.1);
%  options.kernel_z_radius = ceil(size(start,1)*0.1);
%  
%  def3 = Greedy3D_lambda_pre_compressed(...
%         start, last, lambda, options);

options.maximum_deformation_per_step = [1,1,1];
options.convolution_method = 'convnfft'


options.filter_radius = ceil(size(start,1).*0.05);
options.kernel_z_radius = ceil((size(start,1).*0.05) * 2);

def1 = Greedy3D_lambda_pre_compressed(start, last, lambda, options);
    
for i = 1:length(def1.interpolated_images)
    imgs{i} = im2projection_RGB(round(def1.interpolated_images{i}.get_data));
end
imdeform_aniso = [imgs{:}];
imwrite(imdeform_aniso, [figuredir filesep mfilename '_aniso.tif'], 'tif')


options.filter_radius = ceil(size(start,1).*0.05);
options.kernel_z_radius = ceil((size(start,1).*0.05));

def2 = Greedy3D_lambda_pre_compressed(start, last, lambda, options);
    
for i = 1:length(def2.interpolated_images)
    imgs{i} = im2projection_RGB(round(def2.interpolated_images{i}.get_data));
end
imdeform_iso = [imgs{:}];

imwrite(imdeform_iso, [figuredir filesep mfilename '_iso.tif'], 'tif')


options.filter_radius = ceil(size(start,1).*0.1);
options.kernel_z_radius = ceil((size(start,1).*0.1));

def3 = Greedy3D_lambda_pre_compressed(start, last, lambda, options);
    
for i = 1:length(def3.interpolated_images)
    imgs{i} = im2projection_RGB(round(def3.interpolated_images{i}.get_data));
end
imdeform_aniso = [imgs{:}];
imwrite(imdeform_aniso, [figuredir filesep mfilename '_iso_big.tif'], 'tif')




save([figuredir filesep mfilename '.mat'])
end

