function [ framefiles ] = shape_generator( model, positions, savedir, param)
%SHAPE_GENERATOR Summary of this function goes here
%   Detailed explanation goes here

if ~exist('param', 'var')
    param = [];
end

param = ml_initparam(param, struct('skipsynth', false));

if ~exist(savedir, 'dir')
    mkdir(savedir)
end

keepinds = find(~any(isnan(positions),2));
pos_temp = positions(keepinds,:);
    
[u_positions, ~, pos_inds] = unique(pos_temp,'rows');


framefiles_tmp = cell(size(u_positions,1),1);

for i = 1:size(u_positions,1)
    
    
    framefiles_tmp{i} = [savedir filesep 'gen' num2str(i) '.mat'];
    
    tempfile = [framefiles_tmp{i} '.tmp'];
    tempdir = [savedir filesep 'gen' num2str(i)];
    
    if ~exist(tempfile, 'file') && ~exist(framefiles_tmp{i}, 'file') && ~param.skipsynth
        system(['touch ' tempfile])
        
        disp(['Generating image: ' num2str(i) filesep num2str(size(u_positions,1))]);

        if ~exist(tempdir, 'dir')
            mkdir(tempdir)
        end
        frame = makeFrame(model,model.cellShapeModel.shape_space_options,u_positions(i,:),tempdir,i);

        save(framefiles_tmp{i}, 'frame')
    
        system(['rm -r ' tempdir])
        system(['rm ' tempfile]);
    end
end

framefiles_tmp = framefiles_tmp(pos_inds);

framefiles = cell(size(positions,1),1);

framefiles(keepinds) = framefiles_tmp;


end

