function shape_space_hoo_synth( model, savedir )

if ~exist(savedir, 'dir')
    mkdir(savedir)
end


pos = model.cellShapeModel.positions;

for i = 1:size(pos,1)
    if any(isnan(pos(i,:)))
        continue
    end
    
    saveimg =  [savedir filesep 'shape' num2str(i) '.png'];
    saveimg_true =  [savedir filesep 'shape' num2str(i) '_true.png'];
    savefile = [savedir filesep 'shape' num2str(i) '.mat'];
    
    tmpfile = [savefile '.tmp'];
    
    if ~exist(savefile, 'file') && ~exist(tmpfile, 'file')
        system(['touch ' tmpfile]);

        model_tmp = model;

        pos_tmp = pos;
        pos_tmp(i,:) = nan;

        embed_options.positions = pos_tmp;

        embedding = embed_distance_matrix(pos_tmp, embed_options);

        
        model_tmp.cellShapeModel.positions = pos_tmp;
        model_tmp.cellShapeModel.positions = embedding.positions;
        model_tmp.cellShapeModel.convex_hull = embedding.convex_hull;
        model_tmp.cellShapeModel.tessellation = embedding.tessellation;

        model_tmp.nuclearShapeModel = model_tmp.cellShapeModel;

        synthparam.position = pos(i,:); 
        synthparam.tempdir = [savedir filesep 'temp' filesep 'synth' num2str(i)];

        if ~exist(synthparam.tempdir, 'dir')
            mkdir(synthparam.tempdir)
        end
        cd(synthparam.tempdir)

        shape = model2img({model_tmp}, synthparam);

        if ~isempty(shape)
            true_shape = model.cellShapeModel.imfunc(i);
            
            
            if shape{1} == shape{2}
                shape = shape{1};
            else
                shape = shape{1}*2+shape{2};
            end
            
            if size(true_shape,3) == 1
                shape = shape(:,:,2);
            end

            true_shape = model.cellShapeModel.imfunc(i);


            imwrite(im2projection_RGB(true_shape), saveimg_true, 'png')
            imwrite(im2projection_RGB(shape), saveimg, 'png')

            save(savefile, 'shape', 'true_shape')
        
            system(['rm ' tmpfile]);
        end
    end
    
end

