

%load model
%load dnaintens

d = model.cellShapeModel.distances_incomplete;
labels = dnaintens./dnavol;
cellnums = 1:size(d,1);

d_nan = d;
d_nan(logical(eye(size(d)))) = nan;

rminds = all(isnan(d_nan),1);
d(rminds,:) = [];
d(:,rminds) = [];

keepinds = find(~rminds);

labels = labels(keepinds);
cellnums = cellnums(keepinds);

%remove any other entries with nans
rminds = any(isnan(triu(d)),1);
d(rminds,:) = [];
d(:,rminds) = [];

keepinds = find(~rminds);

labels = labels(keepinds);
cellnums = cellnums(keepinds);


nCV = 100;
indices = crossvalind('Kfold', length(labels), nCV);

xi = linspace(0-25, 20, 1000);
n1 = length(labels);
colors = hsv(length(unique(labels)))*0.8;

for n = 1:nCV
    no_err = false;
    while no_err == false 
%         try
            disp(['Hold out ' num2str(n) ' of ' num2str(nCV)])

            [train_inds, test_inds] = crossvalind('HoldOut', n1, 0.5);

            d_train = d(train_inds,:);
            d_train = d_train(:,train_inds);
            
            d_test = d(test_inds,:);
            d_test = d_test(:, train_inds);
            
            train_label = labels(train_inds);
            test_label = labels(test_inds);
            [~,E,V] = svd(d_train);

            eigvects = diag(E).^2;
            orthoproj = d_train*V;
            orthoproj_test = d_test*V;


            fractvar_eig = cumsum(eigvects)./sum(eigvects);
            prctinds = find((fractvar_eig <= 0.99));
            
            if isempty(prctinds)
                prctinds = 1;
            end
            
            prctinds = prctinds(end);

            bufzone = length(fractvar_eig) - prctinds;

            %Trim low eigenvalue dims
            orthoproj = orthoproj(:,1:prctinds);
            orthoproj_test = orthoproj_test(:,1:prctinds);

        %     xm = mean(orthop);
        %     x = x - xm(ones(n,1),:);       % done with the original x
            T = orthoproj'*orthoproj;


            
            [A,B,R,U,V,stats] = canoncorr(orthoproj, train_label');
%             [~, ~, stats ] = manova1(orthoproj, train_label);

% 
%             fract_canon = cumsum(stats.eigenval)/sum(stats.eigenval);
%             canon_ind = find(fract_canon <= 0.9999);
%             canon_ind = canon_ind(end);
% 
%             canonproj = stats.canon;
%             canonproj = canonproj(:,1:canon_ind);
% 
%             canonproj_test = orthoproj_test*stats.eigenvec;
% 
        %     x = linsolve(canonproj, train_label');

            U_test = (orthoproj_test - repmat(mean(orthoproj), [size(orthoproj_test,1),1]))*A;
            V_test = (test_label' - repmat(mean(train_label'), [size(test_label',1),1]))*B;
%             est = canonproj_test(:,1);

          
            no_err = true;
%         catch
%             disp('Retrying cv')
%         end
    end

end


