
clear all;

addpath(genpath('/share/home/murphylab/gj/projects/cellOrganizer/code'));

load('/share/home/murphylab/gj/projects/cellOrganizer/diffeomorphic_all/modelSettings.mat');

ppdir = '/share/home/murphylab/gj/projects/cellOrganizer/diffeomorphic_all/temp/preprocessing';

dnaintens = zeros(1, length(imgdir));
dnavol = zeros(1, length(imgdir));

for i = 1:length(imgdir)
    i
    cellfile = [ppdir filesep 'cell' num2str(i) '.mat'];
    if exist(cellfile, 'file')
        load(cellfile, 'segdna', 'top_slice', 'bot_slice', 'original_segcellsize')
        segdna = ml_downsize(segdna, 1./param.model.downsampling, 'nearest');
        
        segdna = padarray(segdna, [0,0,bot_slice-1], 'pre');
        segdna = padarray(segdna, [0,0,original_segcellsize(3) - (top_slice)], 'post');
        
        segdna = double(segdna);
        imdna = double(imfunc([imgdir{i} filesep 'dna']));
        
        
        dnaintens(i) = sum(imdna(:).*segdna(:));
        dnavol(i) = sum(segdna(:));
    end
end

save('/share/home/murphylab/gj/projects/cellOrganizer/diffeomorphic_all/dnaintens.mat', 'dnaintens', 'dnavol')


mus = fit.mu;
sigmas = fit.Sigma;
xs = min(dnaintens):100000:max(dnaintens);
f = fit.PComponents;

figure, 
for i = 1:length(mus)
    plot(xs, mvnpdf(xs', mus(i), sigmas(i)).*f(i))
    hold on
end

[ks, x] = ksdensity(dnaintens);
plot(x, ks, 'r')