function img2slml_newseg_com_nuc(parentdir, build)
% img2slml_newseg_com_nuc.m generates a joint cell and nuclear shape model
% from G. R. Johnson, T. E. Buck,D. P. Sullivan, G. K. Rohde, and 
% R. F. Murphy (2015) Joint modeling of cell and nuclear shape variation. 
% Molecular Biology of the Cell,
% http://murphylab.web.cmu.edu/software/2015_MBoC_Cell_And_Nuclear_Shape/index.html
%
% Author: Gregory R. Johnson (gj@cs.cmu.edu)
% Created: March 5, 2015
% Nov 2, 2015 - added header block - gj@cs.cmu.edu

% Copyright (C) 2015 Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu


if ~exist('parentdir', 'var')
    parentdir = [];
end

if ~exist('build', 'var')
    build = false;
end


[dimensionality, dnaimgs, cellimgs, param] = script_modelsetup_newseg_com_nuc(parentdir);

param.model.diffeomorphic.useCurrentResults = false;
param.model.diffeomorphic.com_align = 'nuc';

if build
    script_newseg_build_options
end


model = img2slml(dimensionality, dnaimgs, cellimgs, [], param);

system(['chmod ugo+rx ' expdir])



