function [ output_args ] = img2slml_nuc_tub

addpath(genpath('/share/home/murphylab/gj/projects/cellOrganizer/code/'));
expdir = '/share/home/murphylab/gj/projects/cellOrganizer/';

diffeodir = [expdir filesep 'diffeomorphic'];
if ~exist(diffeodir, 'dir')
    mkdir(diffeodir)
end
disp(diffeodir);
cd(diffeodir)


tempDir = [diffeodir filesep 'temp'];



imgparentdirs = {'/images/Hela/3D/Tub/', '/images/Hela/3D/Nuc/'};

c = 1;

for i = 1:length(imgparentdirs)
    [subdirs] = getSubDirs(imgparentdirs{i}, 'cell*');
    for j = 1:length(subdirs)
        dnaimgs{c} = @() imfunc([subdirs{j} filesep 'dna']);
        cellimgs{c} = @() imfunc([subdirs{j} filesep 'cell']);
        parentdir{c} = imgparentdirs{i};
        c = c+1;
    end
end


dimensionality = '3D';
param.model.name = 'tub and nuc diffeomorphic cell shape model';
param.model.id = 'num2str(now)';
param.model.resolution = [1,1,8];
param.model.filename = 'cellModel.mat';
param.nucleus.type = 'diffeomorphic';
param.cell.type = 'diffeomorphic';
param.train.flag = 'framework';
param.verbose = true;
param.debug = true;
param.model.downsampling = [8,8,1];
% param.preprocess = false;

save('modelSettings.mat');

model = img2slml(dimensionality, dnaimgs, cellimgs, [], param);

% if model
%     load('model.mat')
%     save('model', 'model', 'param', 'dimensionality');
% end

end


