function imgs2movie(impaths, moviefilename, framerate)
% Combines frames in individual PNG files "moviefilename"frame*.png to create an avi movie "moviefilename".avi
% requires "mencoder" to be in default PATH
% got Mac OS X version from http://stefpause.com/apple/mac/mplayer-os-x-10rc1-and-mencoder-binaries/

% [status,result]=system(['/opt/local/bin/mencoder "mf://' moviefilename 'frame*.png" -mf fps=1 -o "' moviefilename '.avi" -ovc lavc -lavcopts vcodec=mpeg4']);
% if status~=0 disp(['System call to mencoder returned status=' num2str(status)]); disp(result); end  

if ~exist('framerate', 'var')
    framerate = 30;
end

writerObj = VideoWriter([moviefilename]);

if exist('framerate', 'var')
    writerObj.FrameRate = framerate;
end

open(writerObj);

for i=1:length(impaths)
    frameimg = imread(impaths{i});
    writeVideo(writerObj,frameimg);
end

close(writerObj);
  
end