
parentdirs = {'/Volumes/Data/Documents/Murphylab/projects/shapeSpace/', ...
                '/projects/cellorganizer/gj/shapeSpace/', ...
                '/Users/Greg/Documents/murphylab/projects/shapeSpace/diffeo_tub/'};
            
            
for i = 1:length(parentdirs)
    if exist(parentdirs{i}, 'dir')
        parentdir = parentdirs{i};
    end
end

addpath(genpath([parentdir filesep 'code']));

expdir = [parentdir filesep 'diffeo_tub'];
addpath(genpath([expdir filesep 'code']));


diffeodir = [expdir filesep 'diffeomorphic_hiratio'];
if ~exist(diffeodir, 'dir')
    mkdir(diffeodir)
end
disp(diffeodir);
cd(diffeodir)

settingsfile = [diffeodir filesep 'modelSettings.mat'];


if exist(settingsfile, 'file')
    disp(['Loading existing settings file, ' settingsfile '.'])
    load(settingsfile)
    return
end


tempDir = [diffeodir filesep 'temp'];

imgparentdirs = getSubDirs('/images/Hela/3D/');

c = 1;

for i = 1:length(imgparentdirs)
    [subdirs] = getSubDirs(imgparentdirs{i}, 'cell*');
    for j = 1:length(subdirs)
        dnaimgs{c} = @() imfunc_helamodel([subdirs{j} filesep 'dna']);
        cellimgs{c} = @() imfunc_helamodel([subdirs{j} filesep 'cell']);
        maskimgs{c} = @() imfunc_helamodel([subdirs{j} filesep 'crop']);
        imgparentdir{c} = imgparentdirs{i};
        imgdir{c} = subdirs{j};
        c = c+1;
    end
end

param.model.diffeomorphic.convolution_method = 'convnfft';

dimensionality = '3D';
param.model.name = 'tub and nuc diffeomorphic cell shape model';
param.model.id = 'num2str(now)';
param.model.resolution = [0.049, 0.049, 0.2000];
param.model.filename = 'cellModel.mat';
param.nucleus.type = 'diffeomorphic';
param.cell.type = 'diffeomorphic';
param.train.flag = 'framework';
param.verbose = true;
param.debug = true;
param.model.downsampling = [4.0816,4.0816,1]*2;


param.preprocess = true;

param.masks = maskimgs;

param.model.diffeomorphic.number_windows = 1;
param.saveIntermediateResults = false;

param.model.diffeomorphic.convergence_absolute_error_difference = 0.5;
param.model.diffeomorphic.convergence_absolute_error = 0.1;

param.model.diffeomorphic.scale_z_kernel = true;
% param.model.diffeomorphic.relative_filter_radius = 0.05;

param.model.diffeomorphic.maximum_deformation_per_step = [1,1,1];

param.model.diffeomorphic.embedding.weighted = true;


save(settingsfile);