function ratio_test_2()

%uses multivariate weighted regression
%http://projecteuclid.org/download/pdf_1/euclid.aos/1176325632

system('cd /Users/Greg/Documents/murphylab/projects/shapeSpace/diffeo_tub/diffeomorphic_newesg')

% savefile = ['ratio_test_2.mat'];
% 
% if ~exist(savefile, 'file')
    load('cellModel_cell.mat')
    model_cd = model;
    cd_d = model_cd.cellShapeModel.embedding_info.distances_complete;
    cd_keepinds = model_cd.cellShapeModel.keepinds;


    load('cellModel_nuc.mat')
    model_nd = model;
    nd_d = model_nd.cellShapeModel.embedding_info.distances_complete;
    nd_keepinds = model_nd.cellShapeModel.keepinds;

%     save(savefile, 'cd_d', 'cd_keepinds', 'nd_d', 'nd_keepinds')
% else
%     load(savefile)
% end

keepinds = all([cd_keepinds', nd_keepinds'],2);


cd_d_keepinds = ismember(find(cd_keepinds), find(all([cd_keepinds' nd_keepinds'],2)));
nd_d_keepinds = ismember(find(nd_keepinds), find(all([cd_keepinds' nd_keepinds'],2)));

cd_d = cd_d(cd_d_keepinds,cd_d_keepinds);
nd_d = nd_d(nd_d_keepinds,nd_d_keepinds);

% [nd_full, latent_nd] = cmdscale(nd_d);
% [cd_full, latent_cd] = cmdscale(cd_d);
%                
% latent_nd(latent_nd<0) = 0;
% latent_cd(latent_cd<0) = 0;
% 
% totvar = 0.90;
% 
% nd_totvar = find(cumsum(latent_nd)/sum(latent_nd) >= totvar);
% nd = nd_full(:, 1:nd_totvar(1));
% 
% cd_totvar = find(cumsum(latent_cd)/sum(latent_cd) >= totvar);
% cd = cd_full(:, 1:cd_totvar(1));


embed_param = struct( 'maxdims', 10, ...
        'explained_variance_threshold', 0.90, ...
        'weight_factor', 2, ...
        'just_positions', true ...
        );
    
res = compute_shape_space(nd_d, embed_param);
nd = res.positions;
                
res = compute_shape_space(cd_d, embed_param);
cd = res.positions;
 

nd_kernel = fminsearch(@(x) opt_func([ones(size(nd,1),1) nd], cd, nd_d, x, true), 5);
cd_kernel = fminsearch(@(x) opt_func([ones(size(nd,1),1) cd], nd, cd_d, x, true), 5);


[~, cd_pred] = opt_func([ones(size(nd,1),1) nd], cd, nd_d, nd_kernel, true);
[~, nd_pred] = opt_func([ones(size(nd,1),1) cd], nd, cd_d, cd_kernel, true);

cd_pred_err = sum((cd-cd_pred).^2,2);
nd_pred_err = sum((nd-nd_pred).^2,2);

perms = 1000;

cd_pred_err_perm = zeros(size(cd_pred_err,1), perms);
nd_pred_err_perm = zeros(size(nd_pred_err,1), perms);

for i = 1:perms
    
    cd_perm = cd(randperm(size(cd,1)),:);
    nd_perm = nd(randperm(size(nd,1)),:);
    [~, cd_pred] = opt_func([ones(size(nd,1),1), nd], cd_perm, nd_d, nd_kernel, true);
    [~, nd_pred] = opt_func([ones(size(nd,1),1), cd], nd_perm, cd_d, cd_kernel, true);
    
    cd_pred_err_perm(:,i) = sum((cd_perm - cd_pred).^2,2);
    nd_pred_err_perm(:,i) = sum((nd_perm - nd_pred).^2,2);
end

cd_p_vals = (1 - mean(repmat(cd_pred_err, [1, perms]) < cd_pred_err_perm,2));%*length(cd_pred_err);
nd_p_vals = (1 - mean(repmat(nd_pred_err, [1, perms]) < nd_pred_err_perm,2));%*length(nd_pred_err);

% [h, crit_p, adj_p]=fdr_bh(cd_p_vals,0.05,'pdep')

[~, cd2] = procrustes(nd, cd);

model_cd.cellShapeModel.positions = nan(length(cd_keepinds),size(nd,2));
model_cd.cellShapeModel.positions(keepinds,:) = cd2;

model_nd.cellShapeModel.positions = nan(length(nd_keepinds),size(nd,2));
model_nd.cellShapeModel.positions(keepinds,:) = nd;


npts = size(nd,1);



%color by errors
nd_pred_err_z = zscore(nd_pred_err);

nd_colors = zeros(npts, 3);
nd_colors(keepinds,:) = grayrange2rgb(nd_pred_err_z,prctile(nd_pred_err_z,1),prctile(nd_pred_err_z,99), @jet);

cd_pred_err_z = zscore(cd_pred_err);

cd_colors = zeros(npts, 3);
cd_colors(keepinds,:) = grayrange2rgb(cd_pred_err_z,prctile(cd_pred_err_z,1),prctile(cd_pred_err_z,99), @jet);


% p1.imfunc = @(x) im2projection_RGB(m1.cellShapeModel.imfunc(x)>=2, struct('justz', true, 'cm', @(y) nd_colors(x,:)));
p1.imfunc = @(x) img2flat(model_nd.cellShapeModel.imfunc(x), nd_colors(x,:));
p1.alpha = [0,0,0];

% p2.imfunc = @(x) im2projection_RGB(m2.cellShapeModel.imfunc(x)>=1, struct('justz', true, 'cm', @(y) cd_colors(x,:)));
p2.imfunc = @(x) img2flat(model_cd.cellShapeModel.imfunc(x)>=1, cd_colors(x,:));
p2.alpha = [0,0,0];

%color by p value

p1.subsize = 2500;
p2.subsize = 2500;

figure
title('error')
for i = 1:npts
    line([nd(i,1), cd2(i,1)], [nd(i,2), cd2(i,2)], 'color', 'k')
    hold on
end

showShapeSpaceFigure(model_nd, [], p1);
showShapeSpaceFigure(model_cd, [], p2);


%color by p value
nd_colors = zeros(npts, 3);
nd_colors(keepinds,:) = grayrange2rgb(nd_p_vals, 0, 1, @cool);

cd_colors = zeros(npts, 3);
cd_colors(keepinds,:) = grayrange2rgb(cd_p_vals, 0, 1, @cool);


% p1.imfunc = @(x) im2projection_RGB(m1.cellShapeModel.imfunc(x)>=2, struct('justz', true, 'cm', @(y) nd_colors(x,:)));
p1.imfunc = @(x) img2flat(model_nd.cellShapeModel.imfunc(x), nd_colors(x,:));
p1.alpha = [0,0,0];

% p2.imfunc = @(x) im2projection_RGB(m2.cellShapeModel.imfunc(x)>=1, struct('justz', true, 'cm', @(y) cd_colors(x,:)));
p2.imfunc = @(x) img2flat(model_cd.cellShapeModel.imfunc(x), cd_colors(x,:));
p2.alpha = [0,0,0];

figure
title('p-vals')
for i = 1:npts
    line([nd(i,1), cd2(i,1)], [nd(i,2), cd2(i,2)], 'color', 'k')
    hold on
end

showShapeSpaceFigure(model_nd, [], p1);
showShapeSpaceFigure(model_cd, [], p2);

figure('color', 'w'), 
scatter(zscore(nd_pred_err), zscore(cd_pred_err))

end

function [diff, predval] = opt_func_neighborhood(x,y,dmat,h,hoo)

    if h <= 0
        diff = inf;
        predval = inf;
        return
    end

    if ~exist('dmat', 'var') | isempty(dmat)
        dmat = squareform(pdist(x));
    end

    if ~exist('hoo', 'var') | isempty(hoo)
        hoo = true;
    end


    if hoo
        dmat(logical(eye(size(cd,1)))) = inf;
    end

    w = zeros(size(dmat,1));
    w(:) = mvnpdf(dmat(:), 0, h);

    w = w./ repmat(sum(w,2), [1, size(w,2)]);

    predval = zeros(size(y));

    for i = 1:size(x,1)
        b = (x'*w*x)\x'*w*y;
        predval(i,:) = x(i,:)*b;
    end

    diff = sum(sum((y-predval).^2,2),1);

end

function [diff, predval] = opt_func(x,y,dmat,h, hoo)

if h <= 0
    diff = inf;
    predval = inf;
    return
end

if ~exist('dmat', 'var') | isempty(dmat)
    dmat = squareform(pdist(x));
end

if ~exist('hoo', 'var') | isempty(hoo)
    hoo = true;
end
    
    
if hoo
    dmat(logical(eye(size(cd,1)))) = inf;
end


predval = zeros(size(y));

for i = 1:size(x,1)
    w = diag(mvnpdf(dmat(i,:)', 0, h));

    w = w./sum(w(:));

    b = (x'*w*x)\x'*w*y;
    predval(i,:) = x(i,:)*b;
end

diff = sum(sum((y-predval).^2,2),1);

end
