load([diffeodir filesep 'cellModel.mat'])

savefile = [diffeodir filesep 'anglesOffsets.mat'];    

if ~exist(savefile, 'file')

    numimgs = model.cellShapeModel.numimgs;

    cellAngles = -1 * ones(numimgs,1);
    cellOffsets = -1 * ones(numimgs, 3);

    for i = 1:numimgs
        disp([num2str(i) filesep num2str(numimgs)])
        im1 = model.cellShapeModel.imfunc(i);
        
        if isempty(im1)
            continue;
        end
        
        imcell = im1>0;
        imdna = im1>1;
        cellAngles(i) = imgs2angle(imcell, imdna);
        cellOffsets(i,:) = imgs2offset(imcell, imdna);
    end

    save(savefile, 'cellAngles', 'cellOffsets');
else
    load(savefile)
end

[x,y] = sph2cart(cellAngles, zeros(size(cellAngles)), ones(size(cellAngles)));

cellAngles = [x,y];

