

dna_intens_file = [savedir filesep 'dna_intens.mat'];

if exist(dna_intens_file, 'file')
    load(dna_intens_file)
    return
end

u_im_dna = unique(im_dna);

u_conds = unique(object_info.obj_condition);

dna_inten = zeros(length(im_dna),1);
dna_vol = zeros(length(im_dna),1);
for i = 1:length(u_conds)
    disp([num2str(i) filesep num2str(length(u_conds))])
    obj_inds_cond = find(object_info.obj_condition == u_conds(i));
    
    dna_imgs = im_dna(obj_inds_cond);
    u_imgs = unique(dna_imgs);
    
    for j = 1:length(u_imgs)
        img_inds = ismember(dna_imgs, u_imgs(j));
        obj_inds_img = obj_inds_cond(img_inds);
        
        imgnum = object_info.imgnums(obj_inds_img);
        
        objnums = object_info.objnums(obj_inds_img);
        
        img = double(ml_readimage(img_info.img_path{imgnum}));
        load(img_info.seg_dna_name{imgnum});
        
        for k = 1:length(objnums)
            mask = seg_dna == objnums(k);
            img_mask = img.*mask;
            
            dna_vol(obj_inds_img(k)) = sum(mask(:));
            dna_inten(obj_inds_img(k)) = sum(img_mask(:));
        end            
    end
end
avg_inten = dna_inten./dna_vol;

nbins = 50;

edges_inten = linspace(min(dna_inten), max(dna_inten), nbins);
edges_avg = linspace(min(avg_inten), max(avg_inten), nbins);

h_inten = zeros(length(u_conds), nbins);
h_avg = zeros(length(u_conds), nbins);
cond_centers = zeros(length(u_conds),3);

for i = 1:length(u_conds)
    cond_inds = object_info.obj_condition == u_conds(i);
    cond_inten{i} = dna_inten(cond_inds);
    
    [~, centers] = kmeans(cond_inten{i},3);
    cond_centers(i,:) = sort(centers);
    
    [~, group{i} ] = min(pdist2(cond_centers(i,:)', cond_inten{i}),[],1);
    
    
    h_inten(i,:) = histc(cond_inten{i},edges_inten);
    h_avg(i,:) = histc(avg_inten(object_info.obj_condition == u_conds(i)),edges_avg);
    
    intens_keep(cond_inds) = group{i} == 1;
end


save(dna_intens_file, 'intens_keep', 'group', 'cond_inten', 'dna_inten', 'dna_vol')
