function [ output_args ] = script_figure4( model, dnaintens )
%SCRIPT_FIGURE4 Summary of this function goes here
%   Detailed explanation goes here


% dnaintens = max(dnaintens);

keepinds = ~any(isnan(model.cellShapeModel.positions),2);

dnaintens = dnaintens(keepinds);
positions = model.cellShapeModel.positions(keepinds,:);



dmat = model.cellShapeModel.distances_incomplete(keepinds,keepinds);
[a,b] = mdscale(dmat);

%find the 90% of positive eigenmass
inds = find(cumsum(b.*(b > 0))/sum(b.*(b > 0)) > 0.9);

embed_pos = a(:,1:inds(1));

for i = 1:size(embed_pos,2)
    linmodel = LinearModel.fit(embed_pos(:,i), dnaintens);
    rsq_adj(i) = linmodel.Rsquared.Adjusted;
    rsq_ord(i) = linmodel.Rsquared.Ordinary;
end

for i = 1:size(positions,2)
    linmodel = LinearModel.fit(embed_pos(:,i), dnaintens);
    rsq_adj_pos(i) = linmodel.Rsquared.Adjusted;
    rsq_ord_pos(i) = linmodel.Rsquared.Ordinary;
end
    
dat = [ones(size(embed_pos,1),1) embed_pos embed_pos.^2];
[B, fitinfo] = lasso(dat, dnaintens, 'CV', 10)

[B, fitinfo] = lasso(embed_pos, dnaintens, 'CV', 10)

dna_rgb = grayrange2rgb(dnaintens, [], [], @cool);

param.cm = dna_rgb;




showShapeSpaceFigure(model,[], param)

end

